/*
Copyright (C) 2004 Jacquelin POTIER <jacquelin.potier@free.fr>
Dynamic aspect ratio code Copyright (C) 2004 Jacquelin POTIER <jacquelin.potier@free.fr>

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; version 2 of the License.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
using System;
using System.Windows.Forms;
namespace SpeedTouch_Speed_Monitor
{
    public class ClassMain
    {
        public static void main()
        {
            // create mutex with GUID
            Tools.Threading.ClassSingleInstance single_instance=new Tools.Threading.ClassSingleInstance("SpeedTouchSpeed {1B5B9FFA-1ADF-469c-A5D7-4DD6120F6D37}");
            if(single_instance.IsAnotherInstanceRunning())
            {
                MessageBox.Show("Another instance is running, this one will be stopped","Information",MessageBoxButtons.OK,MessageBoxIcon.Information);
                single_instance.Dispose();
                return;
            }
            Application.Run(new FormLog());
            single_instance.Dispose();
        }

        [STAThread]
        static void Main() 
        {
#if (DEBUG) // let ide catch error
            ClassMain.main();
#else
                try
                {
                    ClassMain.main();
                }
                catch(Exception e)
                {
                    Tools.GUI.Windows.ErrorReport.FormMainCatch fmc=new Tools.GUI.Windows.ErrorReport.FormMainCatch(e);
                    fmc.ShowDialog();
                }
#endif
        }
    }
}
