/*
Copyright (C) 2004 Jacquelin POTIER <jacquelin.potier@free.fr>
Dynamic aspect ratio code Copyright (C) 2004 Jacquelin POTIER <jacquelin.potier@free.fr>

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; version 2 of the License.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
using System;

namespace SpeedTouch_Speed_Monitor
{
	/// <summary>
	/// Summary description for ClassOptions.
	/// </summary>
	public class ClassOptions
	{
        public string speed_touch_ip="10.0.0.138";
        public int speed_touch_port=23;
        public bool use_login_and_password=false;
        public string[] available_interfaces=new string[]{"loop","eth0","ETHoA_1","PPPoE_1"};
        public string interface_name="PPPoE_1";
        public int connection_max_speed_down_in_kbs=64;
        public int connection_max_speed_up_in_kbs=16;
   
        public int speedtouch_telnet_timeout_in_sec=90;
        public int timout_ms=10000;

        public string prompt_cmd="=>";
        public string query_interface_speed="ip iflist\r\n";
        public string login_cmd="Username :";
        public string password_cmd="Password :";
        public string invalid_password="Invalid password.";

        public int nb_query_before_clear_log=4;
        public int refresh_rate_in_sec=5;
        public bool display_topmost=true;
        public Tools.GUI.Components.SimpleChart.CSimpleChart.GRAPH_TYPE graph_type=Tools.GUI.Components.SimpleChart.CSimpleChart.GRAPH_TYPE.BAR;
        public double opacity=1;
        public int download_color=System.Drawing.Color.LightGreen.ToArgb();
        public int upload_color=System.Drawing.Color.LightSkyBlue.ToArgb();
        public int background_color=System.Drawing.Color.Beige.ToArgb();
        public int axis_color=System.Drawing.Color.Red.ToArgb();
        public int grid_color=System.Drawing.Color.DarkOrange.ToArgb();
        public int text_color=System.Drawing.Color.Black.ToArgb();
        public bool show_grid=true;
        public bool transparent_background=false;
        public int number_of_ticks=5;
        public int display_x=0;
        public int display_y=0;
        public int display_width=296;
        public int display_height=104;

        public ClassOptions()
        {
            
        }
        public static ClassOptions load(string config_file_name)
        {
            try
            {
                return (ClassOptions)Tools.Xml.XML_access.XMLDeserializeObject(config_file_name,typeof(ClassOptions));
            }
            catch
            {
                return new ClassOptions();
            }
        }
        public bool save(string config_file_name)
        {
            try
            {
                Tools.Xml.XML_access.XMLSerializeObject(config_file_name,this,typeof(ClassOptions));
                return true;
            }
            catch (Exception e)
            {
                System.Windows.Forms.MessageBox.Show(e.Message,"Error",System.Windows.Forms.MessageBoxButtons.OK,System.Windows.Forms.MessageBoxIcon.Error);
                return false;            
            }
        }
	}
}
