/*
Copyright (C) 2004 Jacquelin POTIER <jacquelin.potier@free.fr>
Dynamic aspect ratio code Copyright (C) 2004 Jacquelin POTIER <jacquelin.potier@free.fr>

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; version 2 of the License.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

namespace SpeedTouch_Speed_Monitor
{
	/// <summary>
	/// Summary description for FormAbout.
	/// </summary>
	public class FormAbout : System.Windows.Forms.Form
	{
        private System.Windows.Forms.Label label_app_name;
        private System.Windows.Forms.Button button_OK;
        private System.Windows.Forms.Label label_app_description;
        private System.Windows.Forms.Label label_app_version;
        private System.Windows.Forms.LinkLabel linkLabel_website;
        private System.Windows.Forms.PictureBox pictureBox;
        private System.Windows.Forms.Label label_website;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public FormAbout()
		{
			InitializeComponent();
            this.label_app_version.Text="Version :"+System.Windows.Forms.Application.ProductVersion;
            Tools.GUI.XPStyle.MakeXPStyle(this);
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}
        private const int WM_QUERYENDSESSION=0x0011;
        protected override void WndProc(ref Message uMsg)
        {
            switch(uMsg.Msg)
            {
                case WM_QUERYENDSESSION:
                    this.force_close=true;
                    break;
            }
            base.WndProc(ref uMsg);
        }
		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(FormAbout));
            this.label_app_name = new System.Windows.Forms.Label();
            this.button_OK = new System.Windows.Forms.Button();
            this.label_app_description = new System.Windows.Forms.Label();
            this.label_app_version = new System.Windows.Forms.Label();
            this.linkLabel_website = new System.Windows.Forms.LinkLabel();
            this.pictureBox = new System.Windows.Forms.PictureBox();
            this.label_website = new System.Windows.Forms.Label();
            this.SuspendLayout();
            // 
            // label_app_name
            // 
            this.label_app_name.Font = new System.Drawing.Font("Arial", 14.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
            this.label_app_name.Location = new System.Drawing.Point(56, 8);
            this.label_app_name.Name = "label_app_name";
            this.label_app_name.Size = new System.Drawing.Size(184, 40);
            this.label_app_name.TabIndex = 0;
            this.label_app_name.Text = "SpeedTouch Speed Monitor";
            this.label_app_name.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
            // 
            // button_OK
            // 
            this.button_OK.Location = new System.Drawing.Point(112, 240);
            this.button_OK.Name = "button_OK";
            this.button_OK.TabIndex = 1;
            this.button_OK.Text = "Ok";
            this.button_OK.Click += new System.EventHandler(this.button_OK_Click);
            // 
            // label_app_description
            // 
            this.label_app_description.Location = new System.Drawing.Point(16, 168);
            this.label_app_description.Name = "label_app_description";
            this.label_app_description.Size = new System.Drawing.Size(272, 32);
            this.label_app_description.TabIndex = 2;
            this.label_app_description.Text = "This application is freeware in open source  under GPL License.";
            this.label_app_description.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
            // 
            // label_app_version
            // 
            this.label_app_version.Location = new System.Drawing.Point(88, 48);
            this.label_app_version.Name = "label_app_version";
            this.label_app_version.Size = new System.Drawing.Size(208, 16);
            this.label_app_version.TabIndex = 3;
            this.label_app_version.Text = "Version";
            // 
            // linkLabel_website
            // 
            this.linkLabel_website.Location = new System.Drawing.Point(73, 216);
            this.linkLabel_website.Name = "linkLabel_website";
            this.linkLabel_website.Size = new System.Drawing.Size(152, 16);
            this.linkLabel_website.TabIndex = 5;
            this.linkLabel_website.TabStop = true;
            this.linkLabel_website.Text = "http://jacquelin.potier.free.fr/";
            this.linkLabel_website.LinkClicked += new System.Windows.Forms.LinkLabelLinkClickedEventHandler(this.linkLabel_website_LinkClicked);
            // 
            // pictureBox
            // 
            this.pictureBox.Cursor = System.Windows.Forms.Cursors.Hand;
            this.pictureBox.Image = ((System.Drawing.Image)(resources.GetObject("pictureBox.Image")));
            this.pictureBox.Location = new System.Drawing.Point(57, 64);
            this.pictureBox.Name = "pictureBox";
            this.pictureBox.Size = new System.Drawing.Size(184, 112);
            this.pictureBox.TabIndex = 8;
            this.pictureBox.TabStop = false;
            this.pictureBox.Click += new System.EventHandler(this.pictureBox_Click);
            // 
            // label_website
            // 
            this.label_website.Location = new System.Drawing.Point(52, 200);
            this.label_website.Name = "label_website";
            this.label_website.Size = new System.Drawing.Size(195, 16);
            this.label_website.TabIndex = 4;
            this.label_website.Text = "Binaries and sources can be found at:";
            // 
            // FormAbout
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.ClientSize = new System.Drawing.Size(298, 272);
            this.Controls.Add(this.linkLabel_website);
            this.Controls.Add(this.label_website);
            this.Controls.Add(this.label_app_version);
            this.Controls.Add(this.label_app_description);
            this.Controls.Add(this.button_OK);
            this.Controls.Add(this.label_app_name);
            this.Controls.Add(this.pictureBox);
            this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedSingle;
            this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
            this.MaximizeBox = false;
            this.MinimizeBox = false;
            this.Name = "FormAbout";
            this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
            this.Text = "About";
            this.TopMost = true;
            this.Closing += new System.ComponentModel.CancelEventHandler(this.Form_Closing);
            this.ResumeLayout(false);

        }
		#endregion

        private void button_OK_Click(object sender, System.EventArgs e)
        {
            this.Hide();
        }

        private void linkLabel_website_LinkClicked(object sender, System.Windows.Forms.LinkLabelLinkClickedEventArgs e)
        {
                this.VisitLink(linkLabel_website.Text);
                // Change the color of the link text by setting LinkVisited 
                // to true.
                this.linkLabel_website.LinkVisited = true;
        }
        private void pictureBox_Click(object sender, System.EventArgs e)
        {
            this.linkLabel_website_LinkClicked(sender,null);
        }
        private void VisitLink(string url)
        {
            try
            {
                //Call the Process.Start method to open the default browser 
                //with a URL:
                System.Diagnostics.Process.Start(url);
            }
            catch (Exception e)
            {
                MessageBox.Show(this,e.Message,"Error",
                    MessageBoxButtons.OK,
                    MessageBoxIcon.Error);
            }
        }
        #region closing
        private bool force_close=false;
        public void Close()
        {
            // close current form
            this.force_close=true;
            base.Close();
        }

        private void Form_Closing(object sender, System.ComponentModel.CancelEventArgs e)
        {
            if (!this.force_close)
            {
                e.Cancel=true;
                this.Hide();
            }
        }
        #endregion

	}
}
