/*
Copyright (C) 2004 Jacquelin POTIER <jacquelin.potier@free.fr>
Dynamic aspect ratio code Copyright (C) 2004 Jacquelin POTIER <jacquelin.potier@free.fr>

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; version 2 of the License.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

namespace SpeedTouch_Speed_Monitor
{
	/// <summary>
	/// Summary description for FormBadUserPass.
	/// </summary>
	public class FormBadUserPass : System.Windows.Forms.Form
	{
        private System.Windows.Forms.Button button_ok;
        private System.Windows.Forms.Button button_cancel;
        private System.Windows.Forms.Label label1;
        private System.Windows.Forms.Label label2;
        private System.Windows.Forms.Label label_infos;
        private System.Windows.Forms.TextBox textBox_login;
        private System.Windows.Forms.TextBox textBox_password;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public FormBadUserPass()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			Tools.GUI.XPStyle.MakeXPStyle(this);
            this.label_infos.Text="Invalid Username or password.\r\n Please enter informations.";
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            this.button_ok = new System.Windows.Forms.Button();
            this.button_cancel = new System.Windows.Forms.Button();
            this.textBox_login = new System.Windows.Forms.TextBox();
            this.textBox_password = new System.Windows.Forms.TextBox();
            this.label1 = new System.Windows.Forms.Label();
            this.label2 = new System.Windows.Forms.Label();
            this.label_infos = new System.Windows.Forms.Label();
            this.SuspendLayout();
            // 
            // button_ok
            // 
            this.button_ok.DialogResult = System.Windows.Forms.DialogResult.OK;
            this.button_ok.Location = new System.Drawing.Point(16, 152);
            this.button_ok.Name = "button_ok";
            this.button_ok.TabIndex = 2;
            this.button_ok.Text = "Ok";
            // 
            // button_cancel
            // 
            this.button_cancel.DialogResult = System.Windows.Forms.DialogResult.Cancel;
            this.button_cancel.Location = new System.Drawing.Point(104, 152);
            this.button_cancel.Name = "button_cancel";
            this.button_cancel.TabIndex = 3;
            this.button_cancel.Text = "Cancel";
            // 
            // textBox_login
            // 
            this.textBox_login.Location = new System.Drawing.Point(32, 72);
            this.textBox_login.Name = "textBox_login";
            this.textBox_login.Size = new System.Drawing.Size(144, 20);
            this.textBox_login.TabIndex = 0;
            this.textBox_login.Text = "";
            // 
            // textBox_password
            // 
            this.textBox_password.Location = new System.Drawing.Point(32, 120);
            this.textBox_password.Name = "textBox_password";
            this.textBox_password.PasswordChar = '.';
            this.textBox_password.Size = new System.Drawing.Size(144, 20);
            this.textBox_password.TabIndex = 1;
            this.textBox_password.Text = "";
            // 
            // label1
            // 
            this.label1.Location = new System.Drawing.Point(16, 48);
            this.label1.Name = "label1";
            this.label1.Size = new System.Drawing.Size(100, 16);
            this.label1.TabIndex = 4;
            this.label1.Text = "User";
            // 
            // label2
            // 
            this.label2.Location = new System.Drawing.Point(16, 104);
            this.label2.Name = "label2";
            this.label2.Size = new System.Drawing.Size(100, 16);
            this.label2.TabIndex = 5;
            this.label2.Text = "Password";
            // 
            // label_infos
            // 
            this.label_infos.Location = new System.Drawing.Point(8, 8);
            this.label_infos.Name = "label_infos";
            this.label_infos.Size = new System.Drawing.Size(176, 32);
            this.label_infos.TabIndex = 6;
            this.label_infos.Text = "Invalid username or password.";
            // 
            // FormBadUserPass
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.ClientSize = new System.Drawing.Size(194, 184);
            this.Controls.Add(this.label_infos);
            this.Controls.Add(this.label2);
            this.Controls.Add(this.label1);
            this.Controls.Add(this.textBox_password);
            this.Controls.Add(this.textBox_login);
            this.Controls.Add(this.button_cancel);
            this.Controls.Add(this.button_ok);
            this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedToolWindow;
            this.Name = "FormBadUserPass";
            this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
            this.Text = "Invalid User/Password";
            this.ResumeLayout(false);

        }
		#endregion

        public bool get_new_login_password(ref string login,ref string password)
        {
            this.textBox_login.Text=login;
            if (this.ShowDialog()==DialogResult.OK)
            {
                login=this.textBox_login.Text;
                password=this.textBox_password.Text;
                return true;
            }
            return false;
        }
	}
}
