/*
Copyright (C) 2004 Jacquelin POTIER <jacquelin.potier@free.fr>
Dynamic aspect ratio code Copyright (C) 2004 Jacquelin POTIER <jacquelin.potier@free.fr>

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; version 2 of the License.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Runtime.InteropServices;
namespace SpeedTouch_Speed_Monitor
{
	/// <summary>
	/// Summary description for FormLog.
	/// </summary>
	public class FormLog : System.Windows.Forms.Form
	{
        private System.ComponentModel.IContainer components;
        private System.Windows.Forms.Panel panel1;
        private System.Windows.Forms.TextBox textBox_telnet;
        private System.Windows.Forms.NotifyIcon notifyIcon;
        private System.Windows.Forms.ContextMenu contextMenu;
        private System.Windows.Forms.MenuItem menuItem_show_hide_display;
        private System.Windows.Forms.MenuItem menuItem_show_hide_log;
        private System.Windows.Forms.MenuItem menuItem_options;
        private System.Windows.Forms.MenuItem menuItem_exit;
        private System.Windows.Forms.MenuItem menuItem1;
        private System.Windows.Forms.MenuItem menuItem2;
        private System.Windows.Forms.MenuItem menuItem_about;
        public System.Windows.Forms.MenuItem menuItem_top_most;
        

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            this.components = new System.ComponentModel.Container();
            System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(FormLog));
            this.panel1 = new System.Windows.Forms.Panel();
            this.textBox_telnet = new System.Windows.Forms.TextBox();
            this.notifyIcon = new System.Windows.Forms.NotifyIcon(this.components);
            this.contextMenu = new System.Windows.Forms.ContextMenu();
            this.menuItem_show_hide_display = new System.Windows.Forms.MenuItem();
            this.menuItem_top_most = new System.Windows.Forms.MenuItem();
            this.menuItem_show_hide_log = new System.Windows.Forms.MenuItem();
            this.menuItem_options = new System.Windows.Forms.MenuItem();
            this.menuItem1 = new System.Windows.Forms.MenuItem();
            this.menuItem_about = new System.Windows.Forms.MenuItem();
            this.menuItem2 = new System.Windows.Forms.MenuItem();
            this.menuItem_exit = new System.Windows.Forms.MenuItem();
            this.panel1.SuspendLayout();
            this.SuspendLayout();
            // 
            // panel1
            // 
            this.panel1.Controls.Add(this.textBox_telnet);
            this.panel1.Dock = System.Windows.Forms.DockStyle.Fill;
            this.panel1.Location = new System.Drawing.Point(0, 0);
            this.panel1.Name = "panel1";
            this.panel1.Size = new System.Drawing.Size(618, 296);
            this.panel1.TabIndex = 2;
            // 
            // textBox_telnet
            // 
            this.textBox_telnet.Dock = System.Windows.Forms.DockStyle.Fill;
            this.textBox_telnet.Location = new System.Drawing.Point(0, 0);
            this.textBox_telnet.Multiline = true;
            this.textBox_telnet.Name = "textBox_telnet";
            this.textBox_telnet.ScrollBars = System.Windows.Forms.ScrollBars.Both;
            this.textBox_telnet.Size = new System.Drawing.Size(618, 296);
            this.textBox_telnet.TabIndex = 3;
            this.textBox_telnet.Text = "";
            // 
            // notifyIcon
            // 
            this.notifyIcon.ContextMenu = this.contextMenu;
            this.notifyIcon.Icon = ((System.Drawing.Icon)(resources.GetObject("notifyIcon.Icon")));
            this.notifyIcon.Text = "SpeedTouch Speed Monitor";
            this.notifyIcon.Visible = true;
            this.notifyIcon.DoubleClick += new System.EventHandler(this.menuItem_show_hide_display_Click);
            // 
            // contextMenu
            // 
            this.contextMenu.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
                                                                                        this.menuItem_show_hide_display,
                                                                                        this.menuItem_top_most,
                                                                                        this.menuItem_show_hide_log,
                                                                                        this.menuItem_options,
                                                                                        this.menuItem1,
                                                                                        this.menuItem_about,
                                                                                        this.menuItem2,
                                                                                        this.menuItem_exit});
            // 
            // menuItem_show_hide_display
            // 
            this.menuItem_show_hide_display.Index = 0;
            this.menuItem_show_hide_display.Text = "Show/Hide";
            this.menuItem_show_hide_display.Click += new System.EventHandler(this.menuItem_show_hide_display_Click);
            // 
            // menuItem_top_most
            // 
            this.menuItem_top_most.Checked = true;
            this.menuItem_top_most.Index = 1;
            this.menuItem_top_most.Text = "Top Window";
            this.menuItem_top_most.Click += new System.EventHandler(this.menuItem_top_most_Click);
            // 
            // menuItem_show_hide_log
            // 
            this.menuItem_show_hide_log.Index = 2;
            this.menuItem_show_hide_log.Text = "Show/Hide Log Window";
            this.menuItem_show_hide_log.Click += new System.EventHandler(this.menuItem_show_hide_log_Click);
            // 
            // menuItem_options
            // 
            this.menuItem_options.Index = 3;
            this.menuItem_options.Text = "Options";
            this.menuItem_options.Click += new System.EventHandler(this.menuItem_options_Click);
            // 
            // menuItem1
            // 
            this.menuItem1.Index = 4;
            this.menuItem1.Text = "-";
            // 
            // menuItem_about
            // 
            this.menuItem_about.Index = 5;
            this.menuItem_about.Text = "About";
            this.menuItem_about.Click += new System.EventHandler(this.menuItem_about_Click);
            // 
            // menuItem2
            // 
            this.menuItem2.Index = 6;
            this.menuItem2.Text = "-";
            // 
            // menuItem_exit
            // 
            this.menuItem_exit.Index = 7;
            this.menuItem_exit.Text = "Exit";
            this.menuItem_exit.Click += new System.EventHandler(this.menuItem_exit_Click);
            // 
            // FormLog
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(7, 11);
            this.ClientSize = new System.Drawing.Size(618, 296);
            this.Controls.Add(this.panel1);
            this.Font = new System.Drawing.Font("Lucida Console", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
            this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog;
            this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
            this.MaximizeBox = false;
            this.Name = "FormLog";
            this.StartPosition = System.Windows.Forms.FormStartPosition.Manual;
            this.Text = "Log Window";
            this.Closing += new System.ComponentModel.CancelEventHandler(this.FormLog_Closing);
            this.Load += new System.EventHandler(this.FormLog_Load);
            this.panel1.ResumeLayout(false);
            this.ResumeLayout(false);

        }
        #endregion

        #region constructor / form load
        public FormLog()
        {
            //
            // Required for Windows Form Designer support
            //
            InitializeComponent();

            // hide log window
            this.ShowInTaskbar=false;
            this.Location=new Point(-this.Width*2,0); // OuterWith should be nice
            // make xp style
            Tools.GUI.XPStyle.MakeXPStyle(this);
            this.evt_logged_in=new System.Threading.ManualResetEvent(false);
            this.evt_form_close=new System.Threading.ManualResetEvent(false);
            this.evt_socket_close=new System.Threading.ManualResetEvent(false);
            this.evt_data_arrival_parsed=new System.Threading.AutoResetEvent(false);
            this.evt_connected=new System.Threading.AutoResetEvent(false);
            this.evt_update_unlock=new System.Threading.ManualResetEvent(true);

            // network initializers
            this.telnet=new easy_socket.Telnet.Telnet(this.textBox_telnet);
            this.telnet.b_allow_beep=false;
            this.clt=new easy_socket.tcp.Socket_Data();
            this.add_events();

            // timer init
            timer=new System.Timers.Timer();
            timer.Elapsed+=new System.Timers.ElapsedEventHandler(timer_Elapsed);

            // get exe path
            this.exe_path=System.Windows.Forms.Application.ExecutablePath;
            int last_pos=this.exe_path.LastIndexOf("\\");
            if (last_pos>0)
                this.exe_path=this.exe_path.Substring(0,last_pos+1);

            // load options
            this.obj_options=ClassOptions.load(this.exe_path+CONFIG_FILENAME);
            this.menuItem_top_most.Checked=this.obj_options.display_topmost;
            // load forms
            this.form_display=new FormDisplay(this.obj_options);
            this.form_display.Location=new Point(this.obj_options.display_x,this.obj_options.display_y);
            this.form_display.Width=this.obj_options.display_width;
            this.form_display.Height=this.obj_options.display_height;
            this.form_options=new FormOptions(this,this.obj_options,this.exe_path+CONFIG_FILENAME);
            this.form_about=new FormAbout();

            this.original_notify_icon=this.notifyIcon.Icon;
        }

        private void FormLog_Load(object sender, System.EventArgs e)
        {
// debug only : allow to quickly test regular expression
//			float d1 =0;
//			float d2 =0;
//			this.parse_speed("			Interface                            Group  MTU   RX         TX         Admin  Oper\r\n"+
//                				"0   loop. . . . . . . . . . . . . .  local  65535 35749023   46819180   UP     [UP]  \r\n"+
//								"1   O2_ADSL . . . . . . . . . . . .  wan    1500  0          0          DOWN   DOWN \r\n"+
//								"2   LocalNetwork. . . . . . . . . .  lan    1500  766435611  1826201121 UP     [UP]  \r\n"+
//								"3   O2_ADSL2plus. . . . . . . . . .  wan    1500  1796545934 631900188  UP     UP \r\n",
//								ref d1,ref d2);
            // show Form Display
            this.form_display.Show();
            // show log window in debug mode
#if (DEBUG)
            this.Show();
#endif
            // allow to access message loop events before form_start returns (sample notify icon exit)
            System.Threading.ThreadStart ths=new System.Threading.ThreadStart(this.form_start);
            System.Threading.Thread th=new System.Threading.Thread(ths);
            th.Start();
        }
        private void form_start()
        {
            // if options file
            if (System.IO.File.Exists(this.exe_path+CONFIG_FILENAME))
                // start stats
                this.start_stat_until_valid();
            else
            {
                // ask modem type to configure some options
                FormModemType frm=new FormModemType();
                switch (frm.GetModemType())
                {
                    case FormModemType.ModemType.SpeedTouch530:
                        this.obj_options.speed_touch_ip="192.168.1.254";
                        this.obj_options.interface_name="Internet";
                        this.obj_options.available_interfaces=new string[]{"Internet","LocalNetwork","loop"};
                        break;

                    // keep default options
                    case FormModemType.ModemType.SpeedTouch510:
                    case FormModemType.ModemType.SpeedTouchHome:
                    case FormModemType.ModemType.SpeedTouchPro:
                    case FormModemType.ModemType.Unknown:
                    default:
                        break;
                }
                this.form_options.UpdateOptions();
                this.show_options();
        	}
        }

        #endregion

        #region members

        private const string CONFIG_FILENAME="options.xml";

        private DateTime old_ticks;
        private float last_rcv_bytes=-1;
        private float last_sent_bytes=-1;
        private string exe_path="";
        private ClassOptions obj_options=null;
        private static System.Timers.Timer timer=null;//instance members are not guaranteed to be thread safe
        private easy_socket.Telnet.Telnet telnet;
        private easy_socket.tcp.Socket_Data clt=null;
        public FormDisplay form_display;
        private FormOptions form_options;
        private FormAbout form_about;
        private System.Threading.ManualResetEvent evt_form_close;
        private System.Threading.ManualResetEvent evt_logged_in;
        private System.Threading.ManualResetEvent evt_socket_close;
        private System.Threading.AutoResetEvent evt_data_arrival_parsed;
        private System.Threading.AutoResetEvent evt_connected;
        private System.Threading.ManualResetEvent evt_update_unlock;
        private Icon original_notify_icon;

        private int nb_query_since_last_log_clear=0;

        public static string Login
        {
            get
            {
                // to access key user must have same or more privileges than yourself
                Microsoft.Win32.RegistryKey rk=System.Windows.Forms.Application.UserAppDataRegistry;
                string str=(string)rk.GetValue("user","");
                return FormLog.decode(str);
            }
            set
            {
                // to access key user must have same or more privileges than yourself
                Microsoft.Win32.RegistryKey rk=System.Windows.Forms.Application.UserAppDataRegistry;
                rk.SetValue("user",FormLog.encode(value));
            }
        }

        public static string Password
        {
            get
            {
                // to access key user must have same or more privileges than yourself
                Microsoft.Win32.RegistryKey rk=System.Windows.Forms.Application.UserAppDataRegistry;
                string str=(string)rk.GetValue("pwd","");
                return FormLog.decode(str);
            }
            set
            {
                // to access key user must have same or more privileges than yourself
                Microsoft.Win32.RegistryKey rk=System.Windows.Forms.Application.UserAppDataRegistry;
                rk.SetValue("pwd",FormLog.encode(value));
            }
        }
        #endregion

        #region password encoding/decoding

        /// <summary>
        /// poor xor encoding could be improved...
        /// </summary>
        /// <param name="str"></param>
        /// <returns></returns>
        public static string encode(string str)
        {
            if (str=="")
                return "";
            byte[] b=easy_socket.hexa_convert.string_to_byte(str);
            for (int i=0;i<b.Length;i++)
                b[i]=(byte)((b[i]^i)&0xff);
            return easy_socket.hexa_convert.byte_to_hexa(b,"");
        }

        public static string decode(string str)
        {
            if (str=="")
                return "";
            byte[] b=easy_socket.hexa_convert.hexa_to_byte(str);
            for (int i=0;i<b.Length;i++)
                b[i]=(byte)((b[i]^i)&0xff);
            return System.Text.Encoding.Default.GetString(b);
        }
        #endregion

        #region waitforstring
        private enum WaitForStringResult
        {
            SUCCESS,
            TIMEOUT,
            SOCKET_CLOSED,
            FORM_CLOSED
        }
        private enum WaitForStringPosition
        {
            ANY,
            BEGIN,
            END
        }
        private WaitForStringResult wait_for_string(string str,int text_box_start_index,int timeout_in_ms)
        {
            return this.wait_for_string(str,text_box_start_index,timeout_in_ms,WaitForStringPosition.ANY);
        }
        private WaitForStringResult wait_for_string(string str,int text_box_start_index,int timeout_in_ms,WaitForStringPosition position)
        {
            int res_wait;
            System.DateTime dt=System.DateTime.Now;
            System.TimeSpan ts;
            bool b_not_timout=true;
            System.Threading.WaitHandle[] whandles=
                new System.Threading.WaitHandle[] {this.evt_data_arrival_parsed,this.evt_socket_close,this.evt_form_close};
            while(b_not_timout)
            {
                res_wait=System.Threading.WaitHandle.WaitAny(whandles,timeout_in_ms,false);
                if (res_wait!=0)
                {
                    switch (res_wait)
                    {
                        case 1:
                            return WaitForStringResult.SOCKET_CLOSED;
                        case 2:
                            return WaitForStringResult.FORM_CLOSED;
                        case System.Threading.WaitHandle.WaitTimeout:
                        default:
                            return WaitForStringResult.TIMEOUT;
                    }
                }
                if (text_box_start_index>this.textBox_telnet.SelectionStart)
                    continue;

                switch(position)
                {
                    case WaitForStringPosition.ANY:
                if (this.textBox_telnet.Text.IndexOf(str,text_box_start_index)>=0)
                    return WaitForStringResult.SUCCESS;
                        break;
                    case WaitForStringPosition.BEGIN:
                    {
                        string str_txt=this.textBox_telnet.Text.Substring(text_box_start_index);
                        if (str_txt.StartsWith(str))
                            return WaitForStringResult.SUCCESS;
                        break;
                    }
                    case WaitForStringPosition.END:
                    {
                        string str_txt=this.textBox_telnet.Text.Substring(text_box_start_index);
                        if (str_txt.EndsWith(str))
                            return WaitForStringResult.SUCCESS;
                        break;
                    }
                }
                ts=System.DateTime.Now.Subtract(dt);
                if (ts.TotalMilliseconds>timeout_in_ms)
                    b_not_timout=false;
            }
            return WaitForStringResult.TIMEOUT;
        }

        /// <summary>
        /// wait for any of string in the str array
        /// functions return WaitForStringResult.SUCCESS as soon as one waited string is found
        /// Index returned is the index of the first found string.
        /// Sample: str=new string[]{"str1","str2"}
        /// "... str2 ... str1" is received in the same packet
        /// in this case, index will be 1 (0 based index)
        /// </summary>
        /// <param name="str">array of string</param>
        /// <param name="text_box_start_index"></param>
        /// <param name="timeout_in_ms"></param>
        /// <param name="found_item_index">index of the first string found</param>
        /// <returns></returns>
        private WaitForStringResult wait_for_multiple_string(string[] str,int text_box_start_index,int timeout_in_ms,ref int found_item_index)
        {
            if (str==null)
                return WaitForStringResult.SUCCESS;
            int res_wait;
            System.DateTime dt=System.DateTime.Now;
            System.TimeSpan ts;
            found_item_index=-1;
            bool b_not_timout=true;
            int cnt;
            int min_pos;
            int pos;
            System.Threading.WaitHandle[] whandles=
                new System.Threading.WaitHandle[] {this.evt_data_arrival_parsed,this.evt_socket_close,this.evt_form_close};
            while(b_not_timout)
            {
                res_wait=System.Threading.WaitHandle.WaitAny(whandles,timeout_in_ms,false);
                if (res_wait!=0)
                {
                    switch (res_wait)
                    {
                        case 1:
                            return WaitForStringResult.SOCKET_CLOSED;
                        case 2:
                            return WaitForStringResult.FORM_CLOSED;
                        case System.Threading.WaitHandle.WaitTimeout:
                        default:
                            return WaitForStringResult.TIMEOUT;
                    }
                }
                if (text_box_start_index>this.textBox_telnet.SelectionStart)
                    continue;
                min_pos=-1;
                for (cnt=0;cnt<str.Length;cnt++)
                {
                    pos=this.textBox_telnet.Text.IndexOf(str[cnt],text_box_start_index);
                    if (pos>=0)
                    {
                        if ((min_pos==-1)||(min_pos>pos))
                        {
                            min_pos=pos;
                            found_item_index=cnt;
                        }
                    }
                }
                if (min_pos!=-1)
                    return WaitForStringResult.SUCCESS;
                ts=System.DateTime.Now.Subtract(dt);
                if (ts.TotalMilliseconds>timeout_in_ms)
                    b_not_timout=false;
            }
            return WaitForStringResult.TIMEOUT;
        }

        private void show_wait_for_string_error_message(WaitForStringResult wait_res,string waited_string)
        {
            switch(wait_res)
            {
                case WaitForStringResult.SOCKET_CLOSED:
                    MessageBox.Show(null,
                        "Socket closed by remote side",
                        "Error",
                        MessageBoxButtons.OK,MessageBoxIcon.Error);
                    break;
                case WaitForStringResult.TIMEOUT:
                    MessageBox.Show(null,
                        "Protocol error (Timeout occurs)\r\nHost may not be a SpeedTouch modem"
#if (DEBUG) // show waited string only in debug mode (don't give full informations in release mode)
                        +"\r\nExpected string: "+waited_string
#endif
                        ,"Error",
                        MessageBoxButtons.OK,MessageBoxIcon.Error);
                    break;
            }

        }

        #endregion

        #region connect & login
        private void start_stat_until_valid()
        {
            if (!start_stat())
            {
                // check the form close event
                if (!this.evt_form_close.WaitOne(0,false))
                    this.show_options();
            }
        }
        private bool start_stat()
        {
            if (!this.connect())
                return false;
            if (!this.login())
            {
                this.clt.close();
                this.evt_socket_close.Set();
                this.evt_logged_in.Reset();
                return false;
            }
            // on success
            // call timer call back and launch timer
            this.timer_Elapsed(null,null);
            // enable timer
            timer.Interval=this.obj_options.refresh_rate_in_sec*1000;
            timer.Enabled=true;
            return true;
        }

        private bool connect()
        {
            this.evt_socket_close.Reset();
            // check the form close event
            if (this.evt_form_close.WaitOne(0,false))
                return false;
            if (this.clt.Connected)
            {
                this.clt.close();
                this.evt_socket_close.Set();
                this.evt_logged_in.Reset();
            }
            this.form_display.Text="Connecting to "+this.obj_options.speed_touch_ip+":"+this.obj_options.speed_touch_port.ToString();
            this.clt.connect(this.obj_options.speed_touch_ip,this.obj_options.speed_touch_port);
            int res_wait=System.Threading.WaitHandle.WaitAny(new System.Threading.WaitHandle[]{this.evt_connected,this.evt_socket_close,this.evt_form_close});
            if (res_wait!=0)
                return false;
            this.form_display.Text="Connected to "+this.obj_options.speed_touch_ip+":"+this.obj_options.speed_touch_port.ToString();
            return true;
        }

        private bool login()
        {
            // check the form close event
            if (this.evt_form_close.WaitOne(0,false))
                return false;
            bool bad_pwd=true;
            int index=0;
            int index2=0;
            int start_pos;
            WaitForStringResult wait_res;
            this.form_display.Text="Login to "+this.obj_options.speed_touch_ip+":"+this.obj_options.speed_touch_port.ToString();
            while(bad_pwd)
            {
                // reset start_pos as connect have clear window (in case of bad password)
                start_pos=this.textBox_telnet.SelectionStart;
                // if Username : not received wait for it
                if (!this.textBox_telnet.Text.EndsWith(this.obj_options.login_cmd))
                {
                    // wait for string Username :
                    wait_res=this.wait_for_string(this.obj_options.login_cmd,start_pos,this.obj_options.timout_ms);
                    if (wait_res!=WaitForStringResult.SUCCESS)
                    {
                        this.show_wait_for_string_error_message(wait_res,this.obj_options.login_cmd);
                        return false;
                    }
                    start_pos+=this.obj_options.login_cmd.Length;
                }
                // if we use login and password
                if (this.obj_options.use_login_and_password)
                {
                    // send user name
                    this.clt.send(FormLog.Login+"\r\n");
                    start_pos+=FormLog.Login.Length;
                }
                // if no usr pwd send \r\n
                else
                {
                    this.clt.send("\r\n");
                    start_pos+=2;
                }
                // wait for string Password: or => if no password
                wait_res=this.wait_for_multiple_string(new string[]{this.obj_options.password_cmd,this.obj_options.prompt_cmd},
                                                        start_pos,
                                                        this.obj_options.timout_ms,
                                                        ref index
                                                        );
                if (wait_res!=WaitForStringResult.SUCCESS)
                {
                    this.show_wait_for_string_error_message(wait_res,this.obj_options.password_cmd+" or "+this.obj_options.prompt_cmd);
                    return false;
                }
                switch(index)
                {
                    case 0:// "Password : "
                        start_pos+=this.obj_options.password_cmd.Length;
                        if (this.obj_options.use_login_and_password)
                        {
                            // send pwd
                            this.clt.send(FormLog.Password+"\r\n");
                        }
                        else// password is required
                        {
                            // send empty pwd
                            this.clt.send("\r\n");
                        }


                        // check for prompt (login ok) or for "Invalid password" (login failure)
                        wait_res=this.wait_for_multiple_string(new string[]{this.obj_options.invalid_password,this.obj_options.prompt_cmd},
                                                                start_pos,
                                                                this.obj_options.timout_ms,
                                                                ref index2
                                                                );
                        if (wait_res!=WaitForStringResult.SUCCESS)
                        {
                            this.show_wait_for_string_error_message(wait_res,this.obj_options.invalid_password+" or "+this.obj_options.prompt_cmd);
                            return false;
                        }
                        
                        // if "Invalid password"
                        if (index2==0)
                        {
                            FormBadUserPass f=new FormBadUserPass();
                            string log=FormLog.Login;
                            string pas=FormLog.Password;
                            if (f.get_new_login_password(ref log,ref pas))
                            {
                                FormLog.Login=log;
                                FormLog.Password=pas;
                                // update form options
                                if (!this.obj_options.use_login_and_password)
                                {
                                    this.obj_options.use_login_and_password=true;
                                    this.form_options.checkBox_login_pass.Checked=true;
                                }
                                this.form_options.textBox_log.Text=log;
                                this.form_options.textBox_pass.Text=pas;
                                start_pos=this.textBox_telnet.Text.Length;
                                if(!this.connect())
                                    return false;
                            }
                            else
                                return false;
                        }
                        else
                            bad_pwd=false;
                        break;
                    case 1:// prompt command
                        if (this.obj_options.use_login_and_password)
                        {
                            this.obj_options.use_login_and_password=false;
                            this.form_options.checkBox_login_pass.Checked=false;
                            MessageBox.Show(null,"Warning no password is required.","Warning",MessageBoxButtons.OK,MessageBoxIcon.Warning);
                        }
                        bad_pwd=false;
                        break;
                }
            }
            this.form_display.Text="Logged to "+this.obj_options.speed_touch_ip+":"+this.obj_options.speed_touch_port.ToString();
            this.evt_logged_in.Set();
            return true;
        }
        #endregion 

        public void reset_vars()
        {
            this.form_display.simple_chart.AutoRedraw=false;
            this.form_display.plot_info_list_down.Clear();
            this.form_display.plot_info_list_up.Clear();
            this.form_display.simple_chart.AutoRedraw=true;
            this.last_rcv_bytes=-1;
            this.last_sent_bytes=-1;
        }
        #region timer elapsed
        
        private void timer_Elapsed(object sender, System.Timers.ElapsedEventArgs e)
        {
            // new thread to avoid to block form events on wait for string
            System.Threading.ThreadStart ths=new System.Threading.ThreadStart(update);
            System.Threading.Thread th=new System.Threading.Thread(ths);
            th.Start();
        }
        private void update()
        {
            // check the form close event
            if (this.evt_form_close.WaitOne(0,false))
                return;
            this.evt_update_unlock.Reset();
            float download_speed;
            float upload_speed;
            float rcv_bytes=0;
            float sent_bytes=0;
            int i_start=this.textBox_telnet.SelectionStart;

            // pause timer during data retreival to avoid new call during parsing of an old one
            timer.Enabled=false;
            // check that we are connected to speed touch
            if (!this.clt.Connected)
            {
                this.start_stat_until_valid();
                this.evt_update_unlock.Set();
                return;// start_stat_until_valid make connection, login and launch timer
            }
            // clear terminal every obj_options.nb_query_before_clear_log times
            this.nb_query_since_last_log_clear=(this.nb_query_since_last_log_clear+1)%this.obj_options.nb_query_before_clear_log;
            if (this.nb_query_since_last_log_clear==0)
                this.clear_terminal();

            i_start=this.textBox_telnet.Text.Length;
            // send query
            this.clt.send(this.obj_options.query_interface_speed);
            i_start+=this.obj_options.query_interface_speed.Length;

            // wait for reply
            WaitForStringResult wait_res=this.wait_for_string(this.obj_options.prompt_cmd,i_start,this.obj_options.timout_ms,WaitForStringPosition.END);
            if (wait_res!=WaitForStringResult.SUCCESS)
            {
                // stop timer
                // timer.Enabled=false; // timer is already stopped

                if (wait_res==WaitForStringResult.FORM_CLOSED)
                    return;
                if (wait_res==WaitForStringResult.TIMEOUT)
                {
                    this.clt.close();
                    this.evt_socket_close.Set();
                    this.evt_logged_in.Reset();
                }
                // show wait for string error msg
                this.show_wait_for_string_error_message(wait_res,this.obj_options.prompt_cmd);

                // show log
                this.Show();

                // show options
                this.show_options();
                this.evt_update_unlock.Set();
                return;
            }
            // parse result
            if (!this.parse_speed(this.textBox_telnet.Text.Substring(i_start),ref rcv_bytes,ref sent_bytes))
            {
                // on parsing error / interface not found -> stop timer
                // timer.Enabled=false; // timer is already stopped

                // close socket
                this.clt.close();
                this.evt_socket_close.Set();
                this.evt_logged_in.Reset();

                // show log
                this.Show();

                // show options
                this.show_options();
                this.evt_update_unlock.Set();
                return;
            }
            DateTime tmp=System.DateTime.Now;
            if (this.last_rcv_bytes>=0)// check it's not the first call
            {
                float nb_sec=(float)((TimeSpan)(tmp-this.old_ticks)).TotalSeconds;
                download_speed=(rcv_bytes-this.last_rcv_bytes)/nb_sec/1024;
                upload_speed=(sent_bytes-this.last_sent_bytes)/nb_sec/1024;

                // update window
                this.form_display.UpdateValue(download_speed,upload_speed);
                // set notify icon text
                this.notifyIcon.Text="Down:"+Math.Round(download_speed,1).ToString()+" Up:"+Math.Round(upload_speed,1).ToString();
                // change notify icon
                this.update_notify_icon(download_speed,upload_speed);
            }
            this.old_ticks=tmp;
            this.last_rcv_bytes=rcv_bytes;
            this.last_sent_bytes=sent_bytes;

            // if refresh rate is slower than speed touch telnet timout, close connection
            if (this.obj_options.refresh_rate_in_sec>this.obj_options.speedtouch_telnet_timeout_in_sec)
            {
                this.clt.close();
                this.evt_socket_close.Set();
                this.evt_logged_in.Reset();
            }

            // resume timer
            timer.Enabled=true;
            this.evt_update_unlock.Set();
        }
        private bool parse_speed(string str,ref float down_speed,ref float up_speed)
        {
			// textbox content is like
			/* patern (speed touch)
			=>ip iflist
			Interface       GRP MTU   RX       TX       TX-DROP  STATUS       HWADDR
			0  loop         1   1500  0        0        0         [UP]  
			1  eth0         2   1500  751823312 1224705594 0         [UP]  00:0e:50:54:da:c0
			2  ETHoA_1      0   1500  0        0        0         [UP]  00:0e:50:54:da:c0
			3  PPPoE_1      0   1492  1223685433 747353582 0         [UP]
			=>
			*/
			/* patern (Thomson-TG587n)
			Interface                            Group  MTU   RX         TX         Admin  Oper
			0   loop. . . . . . . . . . . . . .  local  65535 35749023   46819180   UP     [UP]  
			1   O2_ADSL . . . . . . . . . . . .  wan    1500  0          0          DOWN   DOWN  
			2   LocalNetwork. . . . . . . . . .  lan    1500  766435611  1826201121 UP     [UP]  
			3   O2_ADSL2plus. . . . . . . . . .  wan    1500  1796545934 631900188  UP     UP 
			*/
			string[] res=null;
			string pattern="([0-9]+)( +)("+this.obj_options.interface_name+@")([\. ]+)([0-9a-zA-Z]+)( +)([0-9]+)( +)([0-9]+)( +)([0-9]+)";
            if (Tools.Text.ClassEreg.ereg(pattern,str,ref res))
            {
				down_speed=(float)System.Convert.ToDouble(res[9]);
				up_speed=(float)System.Convert.ToDouble(res[11]);
				return true;
            }
			// else

			MessageBox.Show(null,"Interface "+this.obj_options.interface_name+" not found.","Error",MessageBoxButtons.OK,MessageBoxIcon.Error);
			return false;
            
        }
        private void clear_terminal()
        {
            // parse a fake clear screen command to clear text box
            this.telnet.parse(System.Text.Encoding.Default.GetString(new byte[]{0x1b,0x5b,0x32,0x4a},0,4));
        }

        private void update_notify_icon(float download_speed,float upload_speed)
        {
			try // sometimes g.FillRectangle is happy to throw exceptions
			{
				float download_height=Math.Min(this.notifyIcon.Icon.Height,download_speed*this.notifyIcon.Icon.Height/this.obj_options.connection_max_speed_down_in_kbs);
				float upload_height=Math.Min(this.notifyIcon.Icon.Height,upload_speed*this.notifyIcon.Icon.Height/this.obj_options.connection_max_speed_up_in_kbs);
				float x_down_pos=8*this.notifyIcon.Icon.Height/16;
				float x_up_pos=13*this.notifyIcon.Icon.Height/16;
				float width=3*this.notifyIcon.Icon.Height/16;
				Bitmap bmp=this.original_notify_icon.ToBitmap();
				Graphics g=Graphics.FromImage(bmp);
				g.FillRectangle(this.form_display.plot_info_list_down.GraphBrush,
					x_down_pos,
					this.notifyIcon.Icon.Height-download_height,
					width,
					download_height);
				g.FillRectangle(this.form_display.plot_info_list_up.GraphBrush,
					x_up_pos,
					this.notifyIcon.Icon.Height-upload_height,
					width,
					upload_height);
				this.notifyIcon.Icon=System.Drawing.Icon.FromHandle(bmp.GetHicon());
				g.Dispose();
				bmp.Dispose();
			}
			catch (System.Exception ex)
			{
				
			}
        }

        #endregion

        #region options

        private void show_options()
        {
            Int16 wparam=0;
            Int32 lparam=0;
            // avoid multithreading troubles
            SendMessage(this.Handle,MsgShowOptions,ref wparam,ref lparam);// Invoke can be used too
        }
        public void update_options()
        {
            // update options
            timer.Interval=this.obj_options.refresh_rate_in_sec*1000;
            // reconnect if needed
            if ((this.clt.RemoteIP!=this.obj_options.speed_touch_ip)
                ||(this.clt.RemotePort!=this.obj_options.speed_touch_port)
                ||(!this.clt.Connected))
            {
                // disable timer (else timer event will try to make connection too)
                timer.Enabled=false;
                this.reset_vars();
                this.clt.close();
                this.evt_socket_close.Set();
                this.evt_logged_in.Reset();
                // as start_stat_until_valid can call show_options
                // we create new thread to avoid recursive call
                System.Threading.ThreadStart ths=new System.Threading.ThreadStart(this.start_stat_until_valid);
                System.Threading.Thread th=new System.Threading.Thread(ths);
                th.Start();
            }
        }
        #endregion

        #region retreive_interfaces

        public string[] retreive_interfaces()
        {
            // wait end of speed update
            this.evt_update_unlock.WaitOne();

            // store timer state
            bool timer_state=timer.Enabled;
            // disable timer
            timer.Enabled=false;
            // reconnect if needed
            if ((this.clt.RemoteIP!=this.obj_options.speed_touch_ip)
                ||(this.clt.RemotePort!=this.obj_options.speed_touch_port)
                ||(!this.clt.Connected))
            {
                if (!this.connect())
                    return null;
                if (!this.login())
                {
                    this.clt.close();
                    this.evt_socket_close.Set();
                    this.evt_logged_in.Reset();
                    return null;
                }
            }
            // wait end of login
            if (System.Threading.WaitHandle.WaitAny(new System.Threading.WaitHandle[]{this.evt_logged_in,this.evt_socket_close,this.evt_form_close})!=0)
                return null;
            
            int i_start=this.textBox_telnet.Text.Length;
            // send query
            this.clt.send(this.obj_options.query_interface_speed);
            i_start+=this.obj_options.query_interface_speed.Length;
            // wait for reply
            WaitForStringResult wait_res=this.wait_for_string(this.obj_options.prompt_cmd,i_start,this.obj_options.timout_ms,WaitForStringPosition.END);
            if (wait_res!=WaitForStringResult.SUCCESS)
            {
                if (wait_res==WaitForStringResult.FORM_CLOSED)
                    return null;
                if (wait_res==WaitForStringResult.TIMEOUT)
                {
                    this.clt.close();
                    this.evt_socket_close.Set();
                    this.evt_logged_in.Reset();
                }
                // show wait for string error msg
                this.show_wait_for_string_error_message(wait_res,this.obj_options.prompt_cmd);

                // show log
                this.Show();

                return null;// don't restore timer state: there's an error anyway
            }
            //parse interface
            string[] res=this.parse_interfaces(this.textBox_telnet.Text.Substring(i_start));
            // restore timer state
            timer.Enabled=timer_state;
            return res;
        }
        private string[] parse_interfaces(string str)
        {
            // textbox content is like
            /*
            =>ip iflist
            Interface       GRP MTU   RX       TX       TX-DROP  STATUS       HWADDR
            0  loop         1   1500  0        0        0         [UP]  
            1  eth0         2   1500  751823312 1224705594 0         [UP]  00:0e:50:54:da:c0
            2  ETHoA_1      0   1500  0        0        0         [UP]  00:0e:50:54:da:c0
            3  PPPoE_1      0   1492  1223685433 747353582 0         [UP]
            =>
            */
            string[] lines=str.Split('\n');
            System.Collections.ArrayList al=new ArrayList();
            string[] res=null;
            string pattern="([0-9]+)( +)([^ ]+)";
            foreach(string line in lines)
            {
                if (Tools.Text.ClassEreg.ereg(pattern,line,ref res))
                    al.Add(res[3]);
            }
            if (al.Count==0)
            {
                MessageBox.Show(null,"No interface found.","Error",MessageBoxButtons.OK,MessageBoxIcon.Error);
                this.Show();
                return null;
            }
            return (string[])al.ToArray(typeof(string));
        }
        #endregion

        #region WndProc
        // Message numbers in the third range (0x8000 through 0xBFFF) are available for application
        // to use as private messages. Message in this range do not conflict with system messages.
        private const UInt32 MsgShowOptions=0x8001;
        private const UInt32 MsgShowLog=0x8004;
        private const UInt32 MsgHideLog=0x8005;
        /*
                // don't wait msg processing before returning
                // speedest but some messages are lost :( we use sendmessage instead
                [ DllImport( "User32" ,SetLastError=true)]
                private static extern 
                    Int32 PostMessage(IntPtr hWnd,
                    UInt32 Msg,
                    ref Int16 wParam,
                    ref Int32 lParam
                    );        
        */
        // wait msg processing before returning
        [ DllImport( "User32" ,SetLastError=true)]
        private static extern 
            Int32 SendMessage(IntPtr hWnd,
            UInt32 Msg,
            ref Int16 wParam,
            ref Int32 lParam
            ); 

        private const int WM_QUERYENDSESSION=0x0011;
        //private const int WM_ENDSESSION=0x0016;
        //private const int ENDSESSION_LOGOFF=0x80000000;
        protected override void WndProc(ref Message uMsg)
        {
            switch(uMsg.Msg)
            {
                case (int)MsgShowOptions:
                    this.form_options.Show();
                    return;// don't let message be trasmit to base
                case (int)MsgShowLog:
                    if (this.Location.X<0)// first time showing
                    {
                        // to avoid troubles this.ShowInTaskbar=true; must be called when form is hidden
                        base.Hide();
                        this.ShowInTaskbar=true;
                        base.Show();
                        this.Location=new Point((Screen.PrimaryScreen.WorkingArea.Width-this.Width)/2,(Screen.PrimaryScreen.WorkingArea.Height-this.Height)/2);
                        return;
                    }
                    base.Show();
                    return;// don't let message be trasmit to base
                case (int)MsgHideLog:
                    base.Hide();
                    return;// don't let message be trasmit to base
                case WM_QUERYENDSESSION:
                    this.force_close=true;
                    break;
            }
            base.WndProc(ref uMsg);
        }
        #endregion

        #region hiding & showing

        public void Show()
        {
            Int16 wparam=0;
            Int32 lparam=0;
            // avoid multithreading troubles
            SendMessage(this.Handle,MsgShowLog,ref wparam,ref lparam);
        }
        public void Hide()
        {
            Int16 wparam=0;
            Int32 lparam=0;
            // avoid multithreading troubles
            SendMessage(this.Handle,MsgHideLog,ref wparam,ref lparam);
        }
        #endregion

        #region closing
        private bool force_close=false;
        public void Close()
        {
            // stop timer
            if (timer!=null)
                timer.Enabled=false;

            // hide forms to let more time for events to spread
            this.form_display.Hide();
            this.form_options.Hide();
            this.form_about.Hide();
            this.Hide();
            this.notifyIcon.Visible=false;

            // set event form close
            this.evt_form_close.Set();

            // let waits do their job
            System.Threading.Thread.Sleep(1000);

            // close socket
            if (this.clt!=null)
            {
                this.clt.close();
                this.evt_logged_in.Reset();
                this.remove_events();
                this.evt_socket_close.Set();
                // let waits do their job
                System.Threading.Thread.Sleep(1000);
            }

            // save options to store display size and position
            this.obj_options.display_height=this.form_display.Height;
            this.obj_options.display_width=this.form_display.Width;
            this.obj_options.display_x=this.form_display.Location.X;
            this.obj_options.display_y=this.form_display.Location.Y;
            this.obj_options.save(this.exe_path+CONFIG_FILENAME);

            // close form options
            this.form_options.Close();
            // close form display
            this.form_display.Close();
            // close form about
            this.form_about.Close();
            // close current form
            this.force_close=true;
            base.Close();
        }
        private void FormLog_Closing(object sender, System.ComponentModel.CancelEventArgs e)
        {
            if (!this.force_close)
            {
                e.Cancel=true;
                this.Hide();
            }
        }
        #endregion

        #region menu items events
        private void menuItem_show_hide_display_Click(object sender, System.EventArgs e)
        {
            if (this.form_display.Visible)
                this.form_display.Hide();
            else
                this.form_display.Show();
        }

        private void menuItem_show_hide_log_Click(object sender, System.EventArgs e)
        {
            if (this.Location.X<0)// first time showing
            {
                this.Show();
                return;
            }
            if (this.Visible)
                this.Hide();
            else
            {
                this.Show();
            }
        }

        private void menuItem_options_Click(object sender, System.EventArgs e)
        {
            this.show_options();
        }

        private void menuItem_exit_Click(object sender, System.EventArgs e)
        {
            this.Close();
        }

        private void menuItem_top_most_Click(object sender, System.EventArgs e)
        {
            this.menuItem_top_most.Checked=!this.menuItem_top_most.Checked;
            this.form_options.checkBox_graph_topmost_window.Checked=this.menuItem_top_most.Checked;
            this.obj_options.display_topmost=this.form_display.TopMost;
            // this.form_display.TopMost=this.menuItem_top_most.Checked; // not need because of this.form_options.checkBox_graph_topmost_window checked change event
        }
        private void menuItem_about_Click(object sender, System.EventArgs e)
        {
            this.form_about.Show();
        }
        #endregion

        #region socket events
        protected void add_events()
        {
            this.clt.event_Socket_Data_Closed_by_Remote_Side+= new easy_socket.tcp.Socket_Data_Closed_by_Remote_Side_EventHandler(socket_closed_by_remote_side);
            this.clt.event_Socket_Data_Connected_To_Remote_Host +=new easy_socket.tcp.Socket_Data_Connected_To_Remote_Host_EventHandler(socket_connected_to_remote_host);
            this.clt.event_Socket_Data_DataArrival +=new easy_socket.tcp.Socket_Data_DataArrival_EventHandler(socket_data_arrival);
            this.clt.event_Socket_Data_Error+=new easy_socket.tcp.Socket_Data_Error_EventHandler(socket_error);
        }
        protected void remove_events()
        {
            this.clt.event_Socket_Data_Closed_by_Remote_Side-= new easy_socket.tcp.Socket_Data_Closed_by_Remote_Side_EventHandler(socket_closed_by_remote_side);
            this.clt.event_Socket_Data_Connected_To_Remote_Host -=new easy_socket.tcp.Socket_Data_Connected_To_Remote_Host_EventHandler(socket_connected_to_remote_host);
            this.clt.event_Socket_Data_DataArrival -=new easy_socket.tcp.Socket_Data_DataArrival_EventHandler(socket_data_arrival);
            this.clt.event_Socket_Data_Error-=new easy_socket.tcp.Socket_Data_Error_EventHandler(socket_error);
        }
        protected void socket_closed_by_remote_side(easy_socket.tcp.Socket_Data sender, EventArgs e)
        {
			// 1.0.5 bug solved
			// depending to modem configuration, connections are automatically close after a while
			// --> let timer elapsed event start a new connection
            // timer.Enabled=false;
            this.evt_socket_close.Set();
            this.evt_logged_in.Reset();
            // return to a new line (split != send and send/receive)
            if (!this.textBox_telnet.Text.EndsWith("\r\n"))
				this.textBox_telnet_add("\r\n");

            this.textBox_telnet_add("Connection closed by remote side.\r\n");
        }

        protected void socket_connected_to_remote_host(easy_socket.tcp.Socket_Data sender, EventArgs e)
        {
            if (clt.LocalIPEndPoint!=null)
            {
                this.form_display.Text="Connected to "+sender.RemoteIP+":"+sender.RemotePort.ToString();
                // this.form_display.Text+=" local port:"+clt.LocalIPEndPoint.Port.ToString();
            }
            this.reset_vars();
            this.telnet.reset();
            this.evt_connected.Set();
        }

        protected void socket_data_arrival(easy_socket.tcp.Socket_Data sender, easy_socket.tcp.EventArgs_ReceiveDataSocket e)
        {
            string strdata=System.Text.Encoding.Default.GetString(e.buffer , 0, e.buffer_size );
            // data to show
            byte[][]reply_array=this.telnet.parse(strdata);
            if (reply_array!=null)
                for (int cnt=0;cnt<=reply_array.GetUpperBound(0);cnt++)
                    this.clt.send(reply_array[cnt]);
            this.evt_data_arrival_parsed.Set();
        }
        protected void socket_error(easy_socket.tcp.Socket_Data sender, easy_socket.tcp.EventArgs_Exception e)
        {
            timer.Enabled=false;
            this.evt_socket_close.Set();
            this.evt_logged_in.Reset();
            if (this.textBox_telnet.Text!="")
                if (!this.textBox_telnet.Text.EndsWith("\r\n")) this.textBox_telnet_add("\r\n");
            this.textBox_telnet_add("Socket Error: "+e.exception.Message+"\r\n");
            MessageBox.Show(null,e.exception.Message,"Error",MessageBoxButtons.OK,MessageBoxIcon.Error);
        }
        public void textBox_telnet_add(string txt)
        {
            try// serveur stopped / connection closed can occur when textBox is disposing
            {
                //replace \r\n with \n
                txt=txt.Replace("\r\n","\n");
                //replace \r with \n
                txt=txt.Replace("\r","\n");
                //replace \n with \r\n
                txt=txt.Replace("\n","\r\n");
                this.textBox_telnet.AppendText(txt);

                this.textBox_telnet.SelectionLength=0;
                this.textBox_telnet.SelectionStart=this.textBox_telnet.Text.Length;
                this.textBox_telnet.ScrollToCaret();
            }
            catch{}
        }
        #endregion

    }
}
