/*
Copyright (C) 2004 Jacquelin POTIER <jacquelin.potier@free.fr>
Dynamic aspect ratio code Copyright (C) 2004 Jacquelin POTIER <jacquelin.potier@free.fr>

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; version 2 of the License.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Runtime.InteropServices;
namespace SpeedTouch_Speed_Monitor
{
	/// <summary>
	/// Summary description for FormOptions.
	/// </summary>
	public class FormOptions : System.Windows.Forms.Form
	{
        private System.Windows.Forms.Button button_ok;
        private System.Windows.Forms.Button button_cancel;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

        private ClassOptions options;
        private string filename;
        private FormWait form_wait;
        private FormLog form_log;
        private bool dont_update=false;


        private System.Windows.Forms.Button button_exit;
        private System.Windows.Forms.TabControl tabControl1;
        private System.Windows.Forms.TabPage tabPage_speedtouch;
        private System.Windows.Forms.TabPage tabPage_graph;
        public System.Windows.Forms.CheckBox checkBox_login_pass;
        private System.Windows.Forms.Label label2;
        private System.Windows.Forms.Label label1;
        private System.Windows.Forms.TextBox textBox_port;
        private System.Windows.Forms.TextBox textBox_ip;
        private System.Windows.Forms.GroupBox groupBox_log_pass;
        private System.Windows.Forms.Label label5;
        private System.Windows.Forms.Label label4;
        public System.Windows.Forms.TextBox textBox_pass;
        public System.Windows.Forms.TextBox textBox_log;
        private System.Windows.Forms.Label label3;
        private System.Windows.Forms.GroupBox groupBox_interface;
        private System.Windows.Forms.Label label6;
        private System.Windows.Forms.Label label7;
        private System.Windows.Forms.Button button_interface_update;
        private System.Windows.Forms.ComboBox comboBox_interface;
        private System.Windows.Forms.Label label8;
        private System.Windows.Forms.Label label9;
        private System.Windows.Forms.Label label10;
        private System.Windows.Forms.Label label11;
        private System.Windows.Forms.Label label12;
        private System.Windows.Forms.Label label13;
        public System.Windows.Forms.CheckBox checkBox_graph_topmost_window;
        private System.Windows.Forms.Label label14;
        private System.Windows.Forms.CheckBox checkBox_graph_show_grid;
        private System.Windows.Forms.NumericUpDown numericUpDown_graph_refresh_rate;
        private System.Windows.Forms.TrackBar trackBar_form_display_transparency;
        private System.Windows.Forms.PictureBox pictureBox_graph_download_color;
        private System.Windows.Forms.PictureBox pictureBox_graph_upload_color;
        private System.Windows.Forms.PictureBox pictureBox_graph_background_color;
        private System.Windows.Forms.PictureBox pictureBox_graph_axis_color;
        private System.Windows.Forms.PictureBox pictureBox_graph_grid_color;
        private System.Windows.Forms.Label label15;
        private System.Windows.Forms.ComboBox comboBox_graph_type;
        private System.Windows.Forms.Label label16;
        private System.Windows.Forms.PictureBox pictureBox_graph_text_color;
        private System.Windows.Forms.NumericUpDown numericUpDown_graph_number_ticks;
        private System.Windows.Forms.Label label17;
        private System.Windows.Forms.CheckBox checkBox_graph_background_transparent;
        private System.Windows.Forms.TextBox textBox_graph_connection_speed_down;
        private System.Windows.Forms.Label label18;
        private System.Windows.Forms.Label label19;
        private System.Windows.Forms.TextBox textBox_graph_connection_speed_up;
		private System.Windows.Forms.Label label20;
		private System.Windows.Forms.Label label21;
		private System.Windows.Forms.TextBox textBox_prompt;
        private System.Windows.Forms.ColorDialog colorDialog;


        
		public FormOptions(FormLog form_log,ClassOptions obj_options,string options_filename)
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();
            Tools.GUI.XPStyle.MakeXPStyle(this);

            this.form_wait=new FormWait();
            this.filename=options_filename;
            this.options=obj_options;
            this.form_log=form_log;

            this.load_options();
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(FormOptions));
			this.button_ok = new System.Windows.Forms.Button();
			this.button_cancel = new System.Windows.Forms.Button();
			this.button_exit = new System.Windows.Forms.Button();
			this.tabControl1 = new System.Windows.Forms.TabControl();
			this.tabPage_speedtouch = new System.Windows.Forms.TabPage();
			this.groupBox_interface = new System.Windows.Forms.GroupBox();
			this.button_interface_update = new System.Windows.Forms.Button();
			this.label7 = new System.Windows.Forms.Label();
			this.label6 = new System.Windows.Forms.Label();
			this.comboBox_interface = new System.Windows.Forms.ComboBox();
			this.checkBox_login_pass = new System.Windows.Forms.CheckBox();
			this.label2 = new System.Windows.Forms.Label();
			this.label1 = new System.Windows.Forms.Label();
			this.textBox_port = new System.Windows.Forms.TextBox();
			this.textBox_ip = new System.Windows.Forms.TextBox();
			this.groupBox_log_pass = new System.Windows.Forms.GroupBox();
			this.label5 = new System.Windows.Forms.Label();
			this.label4 = new System.Windows.Forms.Label();
			this.textBox_pass = new System.Windows.Forms.TextBox();
			this.textBox_log = new System.Windows.Forms.TextBox();
			this.tabPage_graph = new System.Windows.Forms.TabPage();
			this.textBox_graph_connection_speed_up = new System.Windows.Forms.TextBox();
			this.label19 = new System.Windows.Forms.Label();
			this.label18 = new System.Windows.Forms.Label();
			this.checkBox_graph_background_transparent = new System.Windows.Forms.CheckBox();
			this.textBox_graph_connection_speed_down = new System.Windows.Forms.TextBox();
			this.label17 = new System.Windows.Forms.Label();
			this.pictureBox_graph_text_color = new System.Windows.Forms.PictureBox();
			this.label16 = new System.Windows.Forms.Label();
			this.comboBox_graph_type = new System.Windows.Forms.ComboBox();
			this.label15 = new System.Windows.Forms.Label();
			this.pictureBox_graph_grid_color = new System.Windows.Forms.PictureBox();
			this.pictureBox_graph_axis_color = new System.Windows.Forms.PictureBox();
			this.pictureBox_graph_background_color = new System.Windows.Forms.PictureBox();
			this.pictureBox_graph_upload_color = new System.Windows.Forms.PictureBox();
			this.pictureBox_graph_download_color = new System.Windows.Forms.PictureBox();
			this.trackBar_form_display_transparency = new System.Windows.Forms.TrackBar();
			this.numericUpDown_graph_refresh_rate = new System.Windows.Forms.NumericUpDown();
			this.numericUpDown_graph_number_ticks = new System.Windows.Forms.NumericUpDown();
			this.checkBox_graph_show_grid = new System.Windows.Forms.CheckBox();
			this.label14 = new System.Windows.Forms.Label();
			this.checkBox_graph_topmost_window = new System.Windows.Forms.CheckBox();
			this.label13 = new System.Windows.Forms.Label();
			this.label12 = new System.Windows.Forms.Label();
			this.label11 = new System.Windows.Forms.Label();
			this.label10 = new System.Windows.Forms.Label();
			this.label9 = new System.Windows.Forms.Label();
			this.label8 = new System.Windows.Forms.Label();
			this.label3 = new System.Windows.Forms.Label();
			this.colorDialog = new System.Windows.Forms.ColorDialog();
			this.label20 = new System.Windows.Forms.Label();
			this.label21 = new System.Windows.Forms.Label();
			this.textBox_prompt = new System.Windows.Forms.TextBox();
			this.tabControl1.SuspendLayout();
			this.tabPage_speedtouch.SuspendLayout();
			this.groupBox_interface.SuspendLayout();
			this.groupBox_log_pass.SuspendLayout();
			this.tabPage_graph.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.trackBar_form_display_transparency)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDown_graph_refresh_rate)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDown_graph_number_ticks)).BeginInit();
			this.SuspendLayout();
			// 
			// button_ok
			// 
			this.button_ok.Location = new System.Drawing.Point(16, 424);
			this.button_ok.Name = "button_ok";
			this.button_ok.TabIndex = 0;
			this.button_ok.Text = "Ok";
			this.button_ok.Click += new System.EventHandler(this.button_ok_Click);
			// 
			// button_cancel
			// 
			this.button_cancel.Location = new System.Drawing.Point(112, 424);
			this.button_cancel.Name = "button_cancel";
			this.button_cancel.TabIndex = 1;
			this.button_cancel.Text = "Cancel";
			this.button_cancel.Click += new System.EventHandler(this.button_cancel_Click);
			// 
			// button_exit
			// 
			this.button_exit.Location = new System.Drawing.Point(208, 424);
			this.button_exit.Name = "button_exit";
			this.button_exit.TabIndex = 2;
			this.button_exit.Text = "Exit";
			this.button_exit.Click += new System.EventHandler(this.button_exit_Click);
			// 
			// tabControl1
			// 
			this.tabControl1.Controls.Add(this.tabPage_speedtouch);
			this.tabControl1.Controls.Add(this.tabPage_graph);
			this.tabControl1.Dock = System.Windows.Forms.DockStyle.Top;
			this.tabControl1.Location = new System.Drawing.Point(0, 0);
			this.tabControl1.Name = "tabControl1";
			this.tabControl1.SelectedIndex = 0;
			this.tabControl1.Size = new System.Drawing.Size(298, 416);
			this.tabControl1.TabIndex = 0;
			// 
			// tabPage_speedtouch
			// 
			this.tabPage_speedtouch.Controls.Add(this.textBox_prompt);
			this.tabPage_speedtouch.Controls.Add(this.label21);
			this.tabPage_speedtouch.Controls.Add(this.label20);
			this.tabPage_speedtouch.Controls.Add(this.groupBox_interface);
			this.tabPage_speedtouch.Controls.Add(this.checkBox_login_pass);
			this.tabPage_speedtouch.Controls.Add(this.label2);
			this.tabPage_speedtouch.Controls.Add(this.label1);
			this.tabPage_speedtouch.Controls.Add(this.textBox_port);
			this.tabPage_speedtouch.Controls.Add(this.textBox_ip);
			this.tabPage_speedtouch.Controls.Add(this.groupBox_log_pass);
			this.tabPage_speedtouch.Location = new System.Drawing.Point(4, 22);
			this.tabPage_speedtouch.Name = "tabPage_speedtouch";
			this.tabPage_speedtouch.Size = new System.Drawing.Size(290, 390);
			this.tabPage_speedtouch.TabIndex = 0;
			this.tabPage_speedtouch.Text = "SpeedTouch";
			// 
			// groupBox_interface
			// 
			this.groupBox_interface.Controls.Add(this.button_interface_update);
			this.groupBox_interface.Controls.Add(this.label7);
			this.groupBox_interface.Controls.Add(this.label6);
			this.groupBox_interface.Controls.Add(this.comboBox_interface);
			this.groupBox_interface.Location = new System.Drawing.Point(24, 160);
			this.groupBox_interface.Name = "groupBox_interface";
			this.groupBox_interface.Size = new System.Drawing.Size(248, 120);
			this.groupBox_interface.TabIndex = 4;
			this.groupBox_interface.TabStop = false;
			this.groupBox_interface.Text = "Interface";
			// 
			// button_interface_update
			// 
			this.button_interface_update.Location = new System.Drawing.Point(128, 88);
			this.button_interface_update.Name = "button_interface_update";
			this.button_interface_update.TabIndex = 1;
			this.button_interface_update.Text = "Update";
			this.button_interface_update.Click += new System.EventHandler(this.button_interface_update_Click);
			// 
			// label7
			// 
			this.label7.Location = new System.Drawing.Point(16, 64);
			this.label7.Name = "label7";
			this.label7.Size = new System.Drawing.Size(224, 16);
			this.label7.TabIndex = 21;
			this.label7.Text = "Update Interface List from Modem";
			// 
			// label6
			// 
			this.label6.Location = new System.Drawing.Point(16, 24);
			this.label6.Name = "label6";
			this.label6.Size = new System.Drawing.Size(100, 16);
			this.label6.TabIndex = 20;
			this.label6.Text = "Choose Interface";
			// 
			// comboBox_interface
			// 
			this.comboBox_interface.Location = new System.Drawing.Point(128, 24);
			this.comboBox_interface.Name = "comboBox_interface";
			this.comboBox_interface.Size = new System.Drawing.Size(112, 21);
			this.comboBox_interface.TabIndex = 0;
			// 
			// checkBox_login_pass
			// 
			this.checkBox_login_pass.Location = new System.Drawing.Point(24, 72);
			this.checkBox_login_pass.Name = "checkBox_login_pass";
			this.checkBox_login_pass.Size = new System.Drawing.Size(160, 16);
			this.checkBox_login_pass.TabIndex = 2;
			this.checkBox_login_pass.Text = "Use Login/Password";
			this.checkBox_login_pass.CheckedChanged += new System.EventHandler(this.checkBox_login_pass_CheckedChanged);
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(24, 40);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(100, 16);
			this.label2.TabIndex = 14;
			this.label2.Text = "Port";
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(24, 16);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(100, 16);
			this.label1.TabIndex = 13;
			this.label1.Text = "IP";
			// 
			// textBox_port
			// 
			this.textBox_port.Location = new System.Drawing.Point(160, 40);
			this.textBox_port.Name = "textBox_port";
			this.textBox_port.TabIndex = 1;
			this.textBox_port.Text = "23";
			// 
			// textBox_ip
			// 
			this.textBox_ip.Location = new System.Drawing.Point(160, 16);
			this.textBox_ip.Name = "textBox_ip";
			this.textBox_ip.TabIndex = 0;
			this.textBox_ip.Text = "10.0.0.138";
			// 
			// groupBox_log_pass
			// 
			this.groupBox_log_pass.Controls.Add(this.label5);
			this.groupBox_log_pass.Controls.Add(this.label4);
			this.groupBox_log_pass.Controls.Add(this.textBox_pass);
			this.groupBox_log_pass.Controls.Add(this.textBox_log);
			this.groupBox_log_pass.Location = new System.Drawing.Point(40, 88);
			this.groupBox_log_pass.Name = "groupBox_log_pass";
			this.groupBox_log_pass.Size = new System.Drawing.Size(231, 72);
			this.groupBox_log_pass.TabIndex = 3;
			this.groupBox_log_pass.TabStop = false;
			// 
			// label5
			// 
			this.label5.Location = new System.Drawing.Point(16, 48);
			this.label5.Name = "label5";
			this.label5.Size = new System.Drawing.Size(100, 16);
			this.label5.TabIndex = 3;
			this.label5.Text = "Password";
			// 
			// label4
			// 
			this.label4.Location = new System.Drawing.Point(16, 24);
			this.label4.Name = "label4";
			this.label4.Size = new System.Drawing.Size(100, 16);
			this.label4.TabIndex = 2;
			this.label4.Text = "Login";
			// 
			// textBox_pass
			// 
			this.textBox_pass.Location = new System.Drawing.Point(120, 40);
			this.textBox_pass.Name = "textBox_pass";
			this.textBox_pass.PasswordChar = '.';
			this.textBox_pass.TabIndex = 1;
			this.textBox_pass.Text = "";
			// 
			// textBox_log
			// 
			this.textBox_log.Location = new System.Drawing.Point(120, 16);
			this.textBox_log.Name = "textBox_log";
			this.textBox_log.TabIndex = 0;
			this.textBox_log.Text = "";
			// 
			// tabPage_graph
			// 
			this.tabPage_graph.Controls.Add(this.textBox_graph_connection_speed_up);
			this.tabPage_graph.Controls.Add(this.label19);
			this.tabPage_graph.Controls.Add(this.label18);
			this.tabPage_graph.Controls.Add(this.checkBox_graph_background_transparent);
			this.tabPage_graph.Controls.Add(this.textBox_graph_connection_speed_down);
			this.tabPage_graph.Controls.Add(this.label17);
			this.tabPage_graph.Controls.Add(this.pictureBox_graph_text_color);
			this.tabPage_graph.Controls.Add(this.label16);
			this.tabPage_graph.Controls.Add(this.comboBox_graph_type);
			this.tabPage_graph.Controls.Add(this.label15);
			this.tabPage_graph.Controls.Add(this.pictureBox_graph_grid_color);
			this.tabPage_graph.Controls.Add(this.pictureBox_graph_axis_color);
			this.tabPage_graph.Controls.Add(this.pictureBox_graph_background_color);
			this.tabPage_graph.Controls.Add(this.pictureBox_graph_upload_color);
			this.tabPage_graph.Controls.Add(this.pictureBox_graph_download_color);
			this.tabPage_graph.Controls.Add(this.trackBar_form_display_transparency);
			this.tabPage_graph.Controls.Add(this.numericUpDown_graph_refresh_rate);
			this.tabPage_graph.Controls.Add(this.numericUpDown_graph_number_ticks);
			this.tabPage_graph.Controls.Add(this.checkBox_graph_show_grid);
			this.tabPage_graph.Controls.Add(this.label14);
			this.tabPage_graph.Controls.Add(this.checkBox_graph_topmost_window);
			this.tabPage_graph.Controls.Add(this.label13);
			this.tabPage_graph.Controls.Add(this.label12);
			this.tabPage_graph.Controls.Add(this.label11);
			this.tabPage_graph.Controls.Add(this.label10);
			this.tabPage_graph.Controls.Add(this.label9);
			this.tabPage_graph.Controls.Add(this.label8);
			this.tabPage_graph.Controls.Add(this.label3);
			this.tabPage_graph.Location = new System.Drawing.Point(4, 22);
			this.tabPage_graph.Name = "tabPage_graph";
			this.tabPage_graph.Size = new System.Drawing.Size(290, 350);
			this.tabPage_graph.TabIndex = 1;
			this.tabPage_graph.Text = "Graph";
			// 
			// textBox_graph_connection_speed_up
			// 
			this.textBox_graph_connection_speed_up.Location = new System.Drawing.Point(224, 328);
			this.textBox_graph_connection_speed_up.Name = "textBox_graph_connection_speed_up";
			this.textBox_graph_connection_speed_up.Size = new System.Drawing.Size(56, 20);
			this.textBox_graph_connection_speed_up.TabIndex = 6;
			this.textBox_graph_connection_speed_up.Text = "16";
			// 
			// label19
			// 
			this.label19.Location = new System.Drawing.Point(176, 330);
			this.label19.Name = "label19";
			this.label19.Size = new System.Drawing.Size(48, 16);
			this.label19.TabIndex = 21;
			this.label19.Text = "Up";
			// 
			// label18
			// 
			this.label18.Location = new System.Drawing.Point(176, 312);
			this.label18.Name = "label18";
			this.label18.Size = new System.Drawing.Size(48, 16);
			this.label18.TabIndex = 20;
			this.label18.Text = "Down";
			// 
			// checkBox_graph_background_transparent
			// 
			this.checkBox_graph_background_transparent.Location = new System.Drawing.Point(192, 168);
			this.checkBox_graph_background_transparent.Name = "checkBox_graph_background_transparent";
			this.checkBox_graph_background_transparent.Size = new System.Drawing.Size(96, 16);
			this.checkBox_graph_background_transparent.TabIndex = 3;
			this.checkBox_graph_background_transparent.Text = "Transparent";
			this.checkBox_graph_background_transparent.CheckedChanged += new System.EventHandler(this.checkBox_graph_background_transparent_CheckedChanged);
			// 
			// textBox_graph_connection_speed_down
			// 
			this.textBox_graph_connection_speed_down.Location = new System.Drawing.Point(224, 308);
			this.textBox_graph_connection_speed_down.Name = "textBox_graph_connection_speed_down";
			this.textBox_graph_connection_speed_down.Size = new System.Drawing.Size(56, 20);
			this.textBox_graph_connection_speed_down.TabIndex = 5;
			this.textBox_graph_connection_speed_down.Text = "56";
			// 
			// label17
			// 
			this.label17.Location = new System.Drawing.Point(24, 312);
			this.label17.Name = "label17";
			this.label17.Size = new System.Drawing.Size(128, 32);
			this.label17.TabIndex = 19;
			this.label17.Text = "Connection max speed (in kbytes per sec)";
			// 
			// pictureBox_graph_text_color
			// 
			this.pictureBox_graph_text_color.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.pictureBox_graph_text_color.Location = new System.Drawing.Point(168, 240);
			this.pictureBox_graph_text_color.Name = "pictureBox_graph_text_color";
			this.pictureBox_graph_text_color.Size = new System.Drawing.Size(16, 16);
			this.pictureBox_graph_text_color.TabIndex = 28;
			this.pictureBox_graph_text_color.TabStop = false;
			this.pictureBox_graph_text_color.Click += new System.EventHandler(this.pictureBox_graph_color_Click);
			// 
			// label16
			// 
			this.label16.Location = new System.Drawing.Point(24, 240);
			this.label16.Name = "label16";
			this.label16.Size = new System.Drawing.Size(100, 16);
			this.label16.TabIndex = 16;
			this.label16.Text = "Text Color";
			// 
			// comboBox_graph_type
			// 
			this.comboBox_graph_type.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
			this.comboBox_graph_type.Items.AddRange(new object[] {
																	 "BARS",
																	 "LINES",
																	 "FILLED LINES"});
			this.comboBox_graph_type.Location = new System.Drawing.Point(168, 96);
			this.comboBox_graph_type.Name = "comboBox_graph_type";
			this.comboBox_graph_type.Size = new System.Drawing.Size(104, 21);
			this.comboBox_graph_type.TabIndex = 2;
			this.comboBox_graph_type.SelectedIndexChanged += new System.EventHandler(this.comboBox_graph_type_SelectedIndexChanged);
			// 
			// label15
			// 
			this.label15.Location = new System.Drawing.Point(24, 96);
			this.label15.Name = "label15";
			this.label15.Size = new System.Drawing.Size(100, 16);
			this.label15.TabIndex = 10;
			this.label15.Text = "Graph Type";
			// 
			// pictureBox_graph_grid_color
			// 
			this.pictureBox_graph_grid_color.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.pictureBox_graph_grid_color.Location = new System.Drawing.Point(168, 216);
			this.pictureBox_graph_grid_color.Name = "pictureBox_graph_grid_color";
			this.pictureBox_graph_grid_color.Size = new System.Drawing.Size(16, 16);
			this.pictureBox_graph_grid_color.TabIndex = 26;
			this.pictureBox_graph_grid_color.TabStop = false;
			this.pictureBox_graph_grid_color.Click += new System.EventHandler(this.pictureBox_graph_color_Click);
			// 
			// pictureBox_graph_axis_color
			// 
			this.pictureBox_graph_axis_color.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.pictureBox_graph_axis_color.Location = new System.Drawing.Point(168, 192);
			this.pictureBox_graph_axis_color.Name = "pictureBox_graph_axis_color";
			this.pictureBox_graph_axis_color.Size = new System.Drawing.Size(16, 16);
			this.pictureBox_graph_axis_color.TabIndex = 25;
			this.pictureBox_graph_axis_color.TabStop = false;
			this.pictureBox_graph_axis_color.Click += new System.EventHandler(this.pictureBox_graph_color_Click);
			// 
			// pictureBox_graph_background_color
			// 
			this.pictureBox_graph_background_color.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.pictureBox_graph_background_color.Location = new System.Drawing.Point(168, 168);
			this.pictureBox_graph_background_color.Name = "pictureBox_graph_background_color";
			this.pictureBox_graph_background_color.Size = new System.Drawing.Size(16, 16);
			this.pictureBox_graph_background_color.TabIndex = 24;
			this.pictureBox_graph_background_color.TabStop = false;
			this.pictureBox_graph_background_color.Click += new System.EventHandler(this.pictureBox_graph_color_Click);
			// 
			// pictureBox_graph_upload_color
			// 
			this.pictureBox_graph_upload_color.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.pictureBox_graph_upload_color.Location = new System.Drawing.Point(168, 144);
			this.pictureBox_graph_upload_color.Name = "pictureBox_graph_upload_color";
			this.pictureBox_graph_upload_color.Size = new System.Drawing.Size(16, 16);
			this.pictureBox_graph_upload_color.TabIndex = 23;
			this.pictureBox_graph_upload_color.TabStop = false;
			this.pictureBox_graph_upload_color.Click += new System.EventHandler(this.pictureBox_graph_color_Click);
			// 
			// pictureBox_graph_download_color
			// 
			this.pictureBox_graph_download_color.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.pictureBox_graph_download_color.Location = new System.Drawing.Point(168, 120);
			this.pictureBox_graph_download_color.Name = "pictureBox_graph_download_color";
			this.pictureBox_graph_download_color.Size = new System.Drawing.Size(16, 16);
			this.pictureBox_graph_download_color.TabIndex = 22;
			this.pictureBox_graph_download_color.TabStop = false;
			this.pictureBox_graph_download_color.Click += new System.EventHandler(this.pictureBox_graph_color_Click);
			// 
			// trackBar_form_display_transparency
			// 
			this.trackBar_form_display_transparency.AutoSize = false;
			this.trackBar_form_display_transparency.Location = new System.Drawing.Point(24, 72);
			this.trackBar_form_display_transparency.Maximum = 100;
			this.trackBar_form_display_transparency.Name = "trackBar_form_display_transparency";
			this.trackBar_form_display_transparency.Size = new System.Drawing.Size(216, 24);
			this.trackBar_form_display_transparency.TabIndex = 1;
			this.trackBar_form_display_transparency.TickStyle = System.Windows.Forms.TickStyle.None;
			this.trackBar_form_display_transparency.Value = 25;
			this.trackBar_form_display_transparency.ValueChanged += new System.EventHandler(this.trackBar_form_display_transparency_ValueChanged);
			// 
			// numericUpDown_graph_refresh_rate
			// 
			this.numericUpDown_graph_refresh_rate.Location = new System.Drawing.Point(168, 8);
			this.numericUpDown_graph_refresh_rate.Maximum = new System.Decimal(new int[] {
																							 -1,
																							 0,
																							 0,
																							 0});
			this.numericUpDown_graph_refresh_rate.Minimum = new System.Decimal(new int[] {
																							 1,
																							 0,
																							 0,
																							 0});
			this.numericUpDown_graph_refresh_rate.Name = "numericUpDown_graph_refresh_rate";
			this.numericUpDown_graph_refresh_rate.Size = new System.Drawing.Size(72, 20);
			this.numericUpDown_graph_refresh_rate.TabIndex = 0;
			this.numericUpDown_graph_refresh_rate.Value = new System.Decimal(new int[] {
																						   5,
																						   0,
																						   0,
																						   0});
			// 
			// numericUpDown_graph_number_ticks
			// 
			this.numericUpDown_graph_number_ticks.Location = new System.Drawing.Point(168, 286);
			this.numericUpDown_graph_number_ticks.Minimum = new System.Decimal(new int[] {
																							 1,
																							 0,
																							 0,
																							 0});
			this.numericUpDown_graph_number_ticks.Name = "numericUpDown_graph_number_ticks";
			this.numericUpDown_graph_number_ticks.Size = new System.Drawing.Size(56, 20);
			this.numericUpDown_graph_number_ticks.TabIndex = 4;
			this.numericUpDown_graph_number_ticks.Value = new System.Decimal(new int[] {
																						   4,
																						   0,
																						   0,
																						   0});
			this.numericUpDown_graph_number_ticks.ValueChanged += new System.EventHandler(this.numericUpDown_graph_number_ticks_ValueChanged);
			// 
			// checkBox_graph_show_grid
			// 
			this.checkBox_graph_show_grid.Location = new System.Drawing.Point(24, 264);
			this.checkBox_graph_show_grid.Name = "checkBox_graph_show_grid";
			this.checkBox_graph_show_grid.Size = new System.Drawing.Size(104, 16);
			this.checkBox_graph_show_grid.TabIndex = 17;
			this.checkBox_graph_show_grid.Text = "Show Grid";
			this.checkBox_graph_show_grid.CheckedChanged += new System.EventHandler(this.checkBox_graph_show_grid_CheckedChanged);
			// 
			// label14
			// 
			this.label14.Location = new System.Drawing.Point(24, 288);
			this.label14.Name = "label14";
			this.label14.Size = new System.Drawing.Size(100, 16);
			this.label14.TabIndex = 18;
			this.label14.Text = "Number of Ticks";
			// 
			// checkBox_graph_topmost_window
			// 
			this.checkBox_graph_topmost_window.Location = new System.Drawing.Point(24, 32);
			this.checkBox_graph_topmost_window.Name = "checkBox_graph_topmost_window";
			this.checkBox_graph_topmost_window.Size = new System.Drawing.Size(152, 16);
			this.checkBox_graph_topmost_window.TabIndex = 8;
			this.checkBox_graph_topmost_window.Text = "Top Most Window";
			this.checkBox_graph_topmost_window.CheckedChanged += new System.EventHandler(this.checkBox_graph_topmost_window_CheckedChanged);
			// 
			// label13
			// 
			this.label13.Location = new System.Drawing.Point(24, 56);
			this.label13.Name = "label13";
			this.label13.Size = new System.Drawing.Size(100, 16);
			this.label13.TabIndex = 9;
			this.label13.Text = "Transparency";
			// 
			// label12
			// 
			this.label12.Location = new System.Drawing.Point(24, 216);
			this.label12.Name = "label12";
			this.label12.Size = new System.Drawing.Size(100, 16);
			this.label12.TabIndex = 15;
			this.label12.Text = "Grid Color";
			// 
			// label11
			// 
			this.label11.Location = new System.Drawing.Point(24, 192);
			this.label11.Name = "label11";
			this.label11.Size = new System.Drawing.Size(100, 16);
			this.label11.TabIndex = 14;
			this.label11.Text = "Axis Color";
			// 
			// label10
			// 
			this.label10.Location = new System.Drawing.Point(24, 168);
			this.label10.Name = "label10";
			this.label10.Size = new System.Drawing.Size(100, 16);
			this.label10.TabIndex = 13;
			this.label10.Text = "BackGround Color";
			// 
			// label9
			// 
			this.label9.Location = new System.Drawing.Point(24, 144);
			this.label9.Name = "label9";
			this.label9.Size = new System.Drawing.Size(100, 16);
			this.label9.TabIndex = 12;
			this.label9.Text = "Upload Color";
			// 
			// label8
			// 
			this.label8.Location = new System.Drawing.Point(24, 120);
			this.label8.Name = "label8";
			this.label8.Size = new System.Drawing.Size(100, 16);
			this.label8.TabIndex = 11;
			this.label8.Text = "Download Color";
			// 
			// label3
			// 
			this.label3.Location = new System.Drawing.Point(24, 10);
			this.label3.Name = "label3";
			this.label3.Size = new System.Drawing.Size(128, 16);
			this.label3.TabIndex = 7;
			this.label3.Text = "Refresh Rate in sec";
			// 
			// label20
			// 
			this.label20.Location = new System.Drawing.Point(24, 328);
			this.label20.Name = "label20";
			this.label20.Size = new System.Drawing.Size(248, 56);
			this.label20.TabIndex = 15;
			this.label20.Text = "Notice : prompt is used to know when the previous command is completed; so if you" +
				" get some errors, check the prompt returned by the modem in the log window";
			// 
			// label21
			// 
			this.label21.Location = new System.Drawing.Point(24, 296);
			this.label21.Name = "label21";
			this.label21.Size = new System.Drawing.Size(80, 16);
			this.label21.TabIndex = 16;
			this.label21.Text = "Prompt";
			// 
			// textBox_prompt
			// 
			this.textBox_prompt.Location = new System.Drawing.Point(152, 296);
			this.textBox_prompt.Name = "textBox_prompt";
			this.textBox_prompt.Size = new System.Drawing.Size(104, 20);
			this.textBox_prompt.TabIndex = 17;
			this.textBox_prompt.Text = "=>";
			// 
			// FormOptions
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(298, 452);
			this.Controls.Add(this.tabControl1);
			this.Controls.Add(this.button_exit);
			this.Controls.Add(this.button_cancel);
			this.Controls.Add(this.button_ok);
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedSingle;
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.MaximizeBox = false;
			this.MinimizeBox = false;
			this.Name = "FormOptions";
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
			this.Text = "Options";
			this.Closing += new System.ComponentModel.CancelEventHandler(this.Form_Closing);
			this.tabControl1.ResumeLayout(false);
			this.tabPage_speedtouch.ResumeLayout(false);
			this.groupBox_interface.ResumeLayout(false);
			this.groupBox_log_pass.ResumeLayout(false);
			this.tabPage_graph.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.trackBar_form_display_transparency)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDown_graph_refresh_rate)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDown_graph_number_ticks)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

        private void checkBox_login_pass_CheckedChanged(object sender, System.EventArgs e)
        {
            this.groupBox_log_pass.Enabled=this.checkBox_login_pass.Checked;
        }

        #region options loading/saving
        public void UpdateOptions()
        {
            this.load_options();
        }
        private void load_options()
        {
            this.dont_update=true;
            // speed touch tab
            this.textBox_ip.Text=this.options.speed_touch_ip;
            this.textBox_port.Text=this.options.speed_touch_port.ToString();
            this.checkBox_login_pass.Checked=this.options.use_login_and_password;
            this.groupBox_log_pass.Enabled=this.checkBox_login_pass.Checked;
            this.textBox_log.Text=FormLog.Login;
            this.textBox_pass.Text=FormLog.Password;
            this.comboBox_interface.Text=this.options.interface_name;
            this.comboBox_interface.Items.Clear();
            this.comboBox_interface.Items.AddRange(this.options.available_interfaces);
			this.textBox_prompt.Text = this.options.prompt_cmd;

            // graph tab
            this.numericUpDown_graph_refresh_rate.Value=this.options.refresh_rate_in_sec;
            this.trackBar_form_display_transparency.Value=100-(int)(this.options.opacity*100);
            this.pictureBox_graph_axis_color.BackColor=System.Drawing.Color.FromArgb(this.options.axis_color);
            this.pictureBox_graph_background_color.BackColor=System.Drawing.Color.FromArgb(this.options.background_color);
            this.pictureBox_graph_download_color.BackColor=System.Drawing.Color.FromArgb(this.options.download_color);
            this.pictureBox_graph_grid_color.BackColor=System.Drawing.Color.FromArgb(this.options.grid_color);
            this.pictureBox_graph_upload_color.BackColor=System.Drawing.Color.FromArgb(this.options.upload_color);
            this.pictureBox_graph_text_color.BackColor=System.Drawing.Color.FromArgb(this.options.text_color);
            this.numericUpDown_graph_number_ticks.Value=this.options.number_of_ticks;
            this.comboBox_graph_type.SelectedIndex=(int)this.options.graph_type;
            this.checkBox_graph_topmost_window.Checked=this.options.display_topmost;
            this.checkBox_graph_show_grid.Checked=this.options.show_grid;
            this.textBox_graph_connection_speed_down.Text=this.options.connection_max_speed_down_in_kbs.ToString();
            this.textBox_graph_connection_speed_up.Text=this.options.connection_max_speed_up_in_kbs.ToString();
            this.checkBox_graph_background_transparent.Checked=this.options.transparent_background;
            this.dont_update=false;
        }
        private bool save_options()
        {
            // speed touch tab
            if (!this.save_connection_options())
                return false;
            this.options.interface_name=this.comboBox_interface.Text;
            this.options.available_interfaces=new string[this.comboBox_interface.Items.Count];
            for (int cnt=0;cnt<this.comboBox_interface.Items.Count;cnt++)
                this.options.available_interfaces[cnt]=this.comboBox_interface.Items[cnt].ToString();
			this.options.prompt_cmd = this.textBox_prompt.Text;

            // graph tab
            this.options.refresh_rate_in_sec=(int)this.numericUpDown_graph_refresh_rate.Value;
            this.options.display_topmost=this.checkBox_graph_topmost_window.Checked;
            this.options.opacity=1.0-(double)(this.trackBar_form_display_transparency.Value)/100;
            this.options.axis_color=this.pictureBox_graph_axis_color.BackColor.ToArgb();
            this.options.background_color=this.pictureBox_graph_background_color.BackColor.ToArgb();
            this.options.download_color=this.pictureBox_graph_download_color.BackColor.ToArgb();
            this.options.grid_color=this.pictureBox_graph_grid_color.BackColor.ToArgb();
            this.options.upload_color=this.pictureBox_graph_upload_color.BackColor.ToArgb();
            this.options.text_color=this.pictureBox_graph_text_color.BackColor.ToArgb();
            this.options.number_of_ticks=(int)this.numericUpDown_graph_number_ticks.Value;
            this.options.graph_type=(Tools.GUI.Components.SimpleChart.CSimpleChart.GRAPH_TYPE)this.comboBox_graph_type.SelectedIndex;
            this.options.show_grid=this.checkBox_graph_show_grid.Checked;
            if (!Tools.GUI.CCheck_user_interface_inputs.check_uint(this.textBox_graph_connection_speed_down.Text))
                return false;
            this.options.connection_max_speed_down_in_kbs=System.Convert.ToInt32(this.textBox_graph_connection_speed_down.Text);
            if (!Tools.GUI.CCheck_user_interface_inputs.check_uint(this.textBox_graph_connection_speed_up.Text))
                return false;
            this.options.connection_max_speed_up_in_kbs=System.Convert.ToInt32(this.textBox_graph_connection_speed_up.Text);
            this.options.transparent_background=this.checkBox_graph_background_transparent.Checked;
            return true;
        }

        private bool save_connection_options()
        {
            this.options.speed_touch_ip=this.textBox_ip.Text;
            if (!Tools.GUI.CCheck_user_interface_inputs.check_ushort(this.textBox_port.Text))
                return false;
            this.options.speed_touch_port=System.Convert.ToInt32(this.textBox_port.Text);
            this.options.use_login_and_password=this.checkBox_login_pass.Checked;
            FormLog.Login=this.textBox_log.Text;
            FormLog.Password=this.textBox_pass.Text;
            return true;
        }
        #endregion

        private void button_interface_update_Click(object sender, System.EventArgs e)
        {
            // save options necessary to connect (ip,port,use pass,login,pass)
            if (!this.save_connection_options())
                return;
            this.Enabled=false;
            System.Threading.ThreadStart ths=new System.Threading.ThreadStart(this.update_interface);
            System.Threading.Thread th=new System.Threading.Thread(ths);
            th.Start();
        }

        #region WndProc
        private const int WM_QUERYENDSESSION=0x0011;
        // Message numbers in the third range (0x8000 through 0xBFFF) are available for application
        // to use as private messages. Message in this range do not conflict with system messages.
        private const UInt32 MsgShowWait=0x8002;
        private const UInt32 MsgHideWait=0x8003;
        /*
                // don't wait msg processing before returning
                // speedest but some messages are lost :( we use sendmessage instead
                [ DllImport( "User32" ,SetLastError=true)]
                private static extern 
                    Int32 PostMessage(IntPtr hWnd,
                    UInt32 Msg,
                    ref Int16 wParam,
                    ref Int32 lParam
                    );        
        */
        // wait msg processing before returning
        [ DllImport( "User32" ,SetLastError=true)]
        private static extern 
            Int32 SendMessage(IntPtr hWnd,
            UInt32 Msg,
            ref Int16 wParam,
            ref Int32 lParam
            ); 

        protected override void WndProc(ref Message uMsg)
        {
            switch(uMsg.Msg)
            {
                case (int)MsgShowWait:
                    this.form_wait.Show();
                    return;// don't let message be trasmit to base
                case (int)MsgHideWait:
                    this.Enabled=true;
                    this.form_wait.Hide();
                    return;// don't let message be trasmit to base
                case WM_QUERYENDSESSION:
                    this.force_close=true;
                    break;
            }
            base.WndProc(ref uMsg);
        }
        #endregion

        private void update_interface()
        {
            Int16 wparam=0;
            Int32 lparam=0;
            // avoid multithreading troubles
            SendMessage(this.Handle,MsgShowWait,ref wparam,ref lparam);
            
            //this.form_wait.Show();
            string[] interfaces_array=this.form_log.retreive_interfaces();
            SendMessage(this.Handle,MsgHideWait,ref wparam,ref lparam);
            //this.form_wait.Hide();
            if (interfaces_array==null)
                return;
            this.comboBox_interface.Items.Clear();
            this.comboBox_interface.Items.AddRange(interfaces_array);
        }

        private void get_color(PictureBox p)
        {
            this.colorDialog.Color=p.BackColor;
            this.colorDialog.ShowDialog(this);
            p.BackColor=this.colorDialog.Color;
        }
        private void pictureBox_graph_color_Click(object sender, System.EventArgs e)
        {
            if (!(sender is PictureBox))
                return;
            PictureBox p=(PictureBox)sender;
            this.get_color(p);
            switch (p.Name)
            {
                case "pictureBox_graph_download_color":
                    if (this.form_log.form_display.plot_info_list_down!=null)
                        this.form_log.form_display.plot_info_list_down.GraphBrush=new SolidBrush(p.BackColor);
                    break;
                case "pictureBox_graph_upload_color":
                    if (this.form_log.form_display.plot_info_list_up!=null)
                        this.form_log.form_display.plot_info_list_up.GraphBrush=new SolidBrush(p.BackColor);
                    break;
                case "pictureBox_graph_background_color":
                    if (this.form_log.form_display.simple_chart!=null)
                        this.form_log.form_display.simple_chart.BackColor=p.BackColor;
                    break;
                case "pictureBox_graph_grid_color":
                    if (this.form_log.form_display.simple_chart!=null)
                        this.form_log.form_display.simple_chart.HorizontalGridPen=new Pen(new SolidBrush(p.BackColor),1);
                    break;
                case "pictureBox_graph_axis_color":
                    if (this.form_log.form_display.simple_chart!=null)
                    {
                        this.form_log.form_display.simple_chart.AutoRedraw=false;
                        this.form_log.form_display.simple_chart.HorizontalAxis.Pen=new Pen(new SolidBrush(p.BackColor),1);
                        this.form_log.form_display.simple_chart.VerticalLeftAxis.Pen=new Pen(new SolidBrush(p.BackColor),1);
                        this.form_log.form_display.simple_chart.HorizontalAxis.Pen.CustomEndCap=new System.Drawing.Drawing2D.AdjustableArrowCap(6, 6, false);
                        this.form_log.form_display.simple_chart.VerticalLeftAxis.Pen.CustomEndCap=new System.Drawing.Drawing2D.AdjustableArrowCap(6, 6, false);
                        this.form_log.form_display.simple_chart.AutoRedraw=true;
                    }
                    break;
                case "pictureBox_graph_text_color":
                    if (this.form_log.form_display.simple_chart!=null)
                        this.form_log.form_display.simple_chart.VerticalLeftAxis.Label.Brush=new SolidBrush(p.BackColor);
                    break;
            }
        }

        #region OK / Cancel / Exit click
        private void button_ok_Click(object sender, System.EventArgs e)
        {
            if (this.comboBox_interface.Text!=this.options.interface_name)
                this.form_log.reset_vars();
            if (!this.save_options())
                return;
            if (!this.options.save(this.filename))
                return;
            this.form_log.update_options();
            this.Hide();
        }

        private void button_cancel_Click(object sender, System.EventArgs e)
        {
            this.Hide();
            // restore options
            this.load_options();
            this.form_log.form_display.reload_options(this.options);
            // restore menu item checked status
            this.form_log.menuItem_top_most.Checked=this.options.display_topmost;
        }

        private void button_exit_Click(object sender, System.EventArgs e)
        {
            this.Hide();
            this.form_log.Close();
        }
        #endregion

        #region closing
        private bool force_close=false;
        public void Close()
        {
            this.form_wait.Close();

            // close current form
            this.force_close=true;
            base.Close();
        }

        private void Form_Closing(object sender, System.ComponentModel.CancelEventArgs e)
        {
            if (!this.force_close)
            {
                e.Cancel=true;
                this.Hide();
            }
        }
        #endregion

        private void checkBox_graph_topmost_window_CheckedChanged(object sender, System.EventArgs e)
        {
            if (dont_update)
                return;
            this.form_log.form_display.TopMost=this.checkBox_graph_topmost_window.Checked;
            this.form_log.menuItem_top_most.Checked=this.form_log.form_display.TopMost;
        }

        private void checkBox_graph_show_grid_CheckedChanged(object sender, System.EventArgs e)
        {
            if (dont_update)
                return;
            if (this.form_log.form_display.simple_chart!=null)
                this.form_log.form_display.simple_chart.ShowHorizontalGrid=this.checkBox_graph_show_grid.Checked;
        }

        private void numericUpDown_graph_number_ticks_ValueChanged(object sender, System.EventArgs e)
        {
            if (dont_update)
                return;
            if (this.form_log.form_display.simple_chart!=null)
                this.form_log.form_display.simple_chart.AutoTickFrequencyNumberOfTicks=(int)this.numericUpDown_graph_number_ticks.Value;
        }

        private void comboBox_graph_type_SelectedIndexChanged(object sender, System.EventArgs e)
        {
            if (dont_update)
                return;
            if (this.form_log.form_display.simple_chart!=null)
                this.form_log.form_display.simple_chart.GraphType=(Tools.GUI.Components.SimpleChart.CSimpleChart.GRAPH_TYPE)this.comboBox_graph_type.SelectedIndex;
        }

        private void trackBar_form_display_transparency_ValueChanged(object sender, System.EventArgs e)
        {
            if (dont_update)
                return;
            this.form_log.form_display.Opacity=(double)(100-this.trackBar_form_display_transparency.Value)/100;
        }

        private void checkBox_graph_background_transparent_CheckedChanged(object sender, System.EventArgs e)
        {
            if (dont_update)
                return;
            if (this.checkBox_graph_background_transparent.Checked)
                this.form_log.form_display.TransparencyKey=this.pictureBox_graph_background_color.BackColor;
            else
                this.form_log.form_display.TransparencyKey=Color.FromArgb(1);// hopping this color is not used 
        }

	}
}
